# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/config/filter/http/aws_request_signing/v2alpha/aws_request_signing.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("AwsRequestSigning",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class AwsRequestSigning(betterproto2.Message):
    """
    [#protodoc-title: AwsRequestSigning]
    AwsRequestSigning :ref:`configuration overview <config_http_filters_aws_request_signing>`.
    [#extension: envoy.filters.http.aws_request_signing]

    Top level configuration for the AWS request signing filter.
    """

    service_name: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The `service namespace
    <https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html#genref-aws-service-namespaces>`_
    of the HTTP endpoint.

    Example: s3
    """

    region: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The `region <https://docs.aws.amazon.com/general/latest/gr/rande.html>`_ hosting the HTTP
    endpoint.

    Example: us-west-2
    """

    host_rewrite: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    Indicates that before signing headers, the host header will be swapped with
    this value. If not set or empty, the original host header value
    will be used and no rewrite will happen.

    Note: this rewrite affects both signing and host header forwarding. However, this
    option shouldn't be used with
    :ref:`HCM host rewrite <envoy_api_field_route.RouteAction.host_rewrite>` given that the
    value set here would be used for signing whereas the value set in the HCM would be used
    for host header forwarding which is not the desired outcome.
    """


default_message_pool.register_message(
    "envoy.config.filter.http.aws_request_signing.v2alpha",
    "AwsRequestSigning",
    AwsRequestSigning,
)
