# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/config/filter/http/rate_limit/v2/rate_limit.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("RateLimit",)

import datetime
from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class RateLimit(betterproto2.Message):
    """
    [#protodoc-title: Rate limit]
    Rate limit :ref:`configuration overview <config_http_filters_rate_limit>`.
    [#extension: envoy.filters.http.ratelimit]

    [#next-free-field: 8]
    """

    domain: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The rate limit domain to use when calling the rate limit service.
    """

    stage: "int" = betterproto2.field(2, betterproto2.TYPE_UINT32)
    """
    Specifies the rate limit configurations to be applied with the same
    stage number. If not set, the default stage number is 0.

    .. note::

     The filter supports a range of 0 - 10 inclusively for stage numbers.
    """

    request_type: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    The type of requests the filter should apply to. The supported
    types are *internal*, *external* or *both*. A request is considered internal if
    :ref:`x-envoy-internal<config_http_conn_man_headers_x-envoy-internal>` is set to true. If
    :ref:`x-envoy-internal<config_http_conn_man_headers_x-envoy-internal>` is not set or false, a
    request is considered external. The filter defaults to *both*, and it will apply to all request
    types.
    """

    timeout: "datetime.timedelta | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The timeout in milliseconds for the rate limit service RPC. If not
    set, this defaults to 20ms.
    """

    failure_mode_deny: "bool" = betterproto2.field(5, betterproto2.TYPE_BOOL)
    """
    The filter's behaviour in case the rate limiting service does
    not respond back. When it is set to true, Envoy will not allow traffic in case of
    communication failure between rate limiting service and the proxy.
    Defaults to false.
    """

    rate_limited_as_resource_exhausted: "bool" = betterproto2.field(
        6, betterproto2.TYPE_BOOL
    )
    """
    Specifies whether a `RESOURCE_EXHAUSTED` gRPC code must be returned instead
    of the default `UNAVAILABLE` gRPC code for a rate limited gRPC call. The
    HTTP code will be 200 for a gRPC response.
    """

    rate_limit_service: "____ratelimit__v2__.RateLimitServiceConfig | None" = (
        betterproto2.field(7, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration for an external rate limit service provider. If not
    specified, any calls to the rate limit service will immediately return
    success.
    """


default_message_pool.register_message(
    "envoy.config.filter.http.rate_limit.v2", "RateLimit", RateLimit
)


from .......google import protobuf as ______google__protobuf__
from .....ratelimit import v2 as ____ratelimit__v2__
