# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/config/filter/http/squash/v2/squash.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("Squash",)

import datetime
from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class Squash(betterproto2.Message):
    """
    [#protodoc-title: Squash]
    Squash :ref:`configuration overview <config_http_filters_squash>`.
    [#extension: envoy.filters.http.squash]

    [#next-free-field: 6]
    """

    cluster: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The name of the cluster that hosts the Squash server.
    """

    attachment_template: "______google__protobuf__.Struct | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    When the filter requests the Squash server to create a DebugAttachment, it will use this
    structure as template for the body of the request. It can contain reference to environment
    variables in the form of '{{ ENV_VAR_NAME }}'. These can be used to provide the Squash server
    with more information to find the process to attach the debugger to. For example, in a
    Istio/k8s environment, this will contain information on the pod:

    .. code-block:: json

     {
       "spec": {
         "attachment": {
           "pod": "{{ POD_NAME }}",
           "namespace": "{{ POD_NAMESPACE }}"
         },
         "match_request": true
       }
     }

    (where POD_NAME, POD_NAMESPACE are configured in the pod via the Downward API)
    """

    request_timeout: "datetime.timedelta | None" = betterproto2.field(
        3,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The timeout for individual requests sent to the Squash cluster. Defaults to 1 second.
    """

    attachment_timeout: "datetime.timedelta | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The total timeout Squash will delay a request and wait for it to be attached. Defaults to 60
    seconds.
    """

    attachment_poll_period: "datetime.timedelta | None" = betterproto2.field(
        5,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    Amount of time to poll for the status of the attachment object in the Squash server
    (to check if has been attached). Defaults to 1 second.
    """


default_message_pool.register_message(
    "envoy.config.filter.http.squash.v2", "Squash", Squash
)


from .......google import protobuf as ______google__protobuf__
