# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/config/filter/network/ext_authz/v2/ext_authz.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("ExtAuthz",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class ExtAuthz(betterproto2.Message):
    """
    [#protodoc-title: Network External Authorization ]
    The network layer external authorization service configuration
    :ref:`configuration overview <config_network_filters_ext_authz>`.
    [#extension: envoy.filters.network.ext_authz]

    External Authorization filter calls out to an external service over the
    gRPC Authorization API defined by
    :ref:`CheckRequest <envoy_api_msg_service.auth.v2.CheckRequest>`.
    A failed check will cause this filter to close the TCP connection.
    """

    stat_prefix: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The prefix to use when emitting statistics.
    """

    grpc_service: "_____api__v2__core__.GrpcService | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The external authorization gRPC service configuration.
    The default timeout is set to 200ms by this filter.
    """

    failure_mode_allow: "bool" = betterproto2.field(3, betterproto2.TYPE_BOOL)
    """
    The filter's behaviour in case the external authorization service does
    not respond back. When it is set to true, Envoy will also allow traffic in case of
    communication failure between authorization service and the proxy.
    Defaults to false.
    """

    include_peer_certificate: "bool" = betterproto2.field(4, betterproto2.TYPE_BOOL)
    """
    Specifies if the peer certificate is sent to the external service.

    When this field is true, Envoy will include the peer X.509 certificate, if available, in the
    :ref:`certificate<envoy_api_field_service.auth.v2.AttributeContext.Peer.certificate>`.
    """


default_message_pool.register_message(
    "envoy.config.filter.network.ext_authz.v2", "ExtAuthz", ExtAuthz
)


from ......api.v2 import core as _____api__v2__core__
