# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/config/filter/network/kafka_broker/v2alpha1/kafka_broker.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "IdBasedBrokerRewriteRule",
    "IdBasedBrokerRewriteSpec",
    "KafkaBroker",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class IdBasedBrokerRewriteRule(betterproto2.Message):
    """
    Defines a rule to rewrite broker address data.
    """

    id: "int" = betterproto2.field(1, betterproto2.TYPE_UINT32)
    """
    Broker ID to match.
    """

    host: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The host value to use (resembling the host part of Kafka's advertised.listeners).
    The value should point to the Envoy (not Kafka) listener, so that all client traffic goes
    through Envoy.
    """

    port: "int" = betterproto2.field(3, betterproto2.TYPE_UINT32)
    """
    The port value to use (resembling the port part of Kafka's advertised.listeners).
    The value should point to the Envoy (not Kafka) listener, so that all client traffic goes
    through Envoy.
    """


default_message_pool.register_message(
    "envoy.config.filter.network.kafka_broker.v2alpha1",
    "IdBasedBrokerRewriteRule",
    IdBasedBrokerRewriteRule,
)


@dataclass(eq=False, repr=False)
class IdBasedBrokerRewriteSpec(betterproto2.Message):
    """
    Collection of rules matching by broker ID.
    """

    rules: "list[IdBasedBrokerRewriteRule]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )


default_message_pool.register_message(
    "envoy.config.filter.network.kafka_broker.v2alpha1",
    "IdBasedBrokerRewriteSpec",
    IdBasedBrokerRewriteSpec,
)


@dataclass(eq=False, repr=False)
class KafkaBroker(betterproto2.Message):
    """
    [#protodoc-title: Kafka Broker]
    Kafka Broker :ref:`configuration overview <config_network_filters_kafka_broker>`.
    [#extension: envoy.filters.network.kafka_broker]
    [#next-free-field: 6]

    Oneofs:
        - broker_address_rewrite_spec: Optional broker address rewrite specification.
            Allows the broker filter to rewrite Kafka responses so that all connections established by
            the Kafka clients point to Envoy.
            This allows Kafka cluster not to configure its 'advertised.listeners' property
            (as the necessary re-pointing will be done by this filter).
            This collection of rules should cover all brokers in the cluster that is being proxied,
            otherwise some nodes' addresses might leak to the downstream clients.
    """

    stat_prefix: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The prefix to use when emitting :ref:`statistics <config_network_filters_kafka_broker_stats>`.
    """

    force_response_rewrite: "bool" = betterproto2.field(2, betterproto2.TYPE_BOOL)
    """
    Set to true if broker filter should attempt to serialize the received responses from the
    upstream broker instead of passing received bytes as is.
    Disabled by default.
    """

    id_based_broker_address_rewrite_spec: "IdBasedBrokerRewriteSpec | None" = (
        betterproto2.field(
            3,
            betterproto2.TYPE_MESSAGE,
            optional=True,
            group="broker_address_rewrite_spec",
        )
    )
    """
    Broker address rewrite rules that match by broker ID.
    """

    api_keys_allowed: "list[int]" = betterproto2.field(
        4, betterproto2.TYPE_UINT32, repeated=True
    )
    """
    Optional list of allowed Kafka API keys. Only requests with provided API keys will be
    routed, otherwise the connection will be closed. No effect if empty.
    """

    api_keys_denied: "list[int]" = betterproto2.field(
        5, betterproto2.TYPE_UINT32, repeated=True
    )
    """
    Optional list of denied Kafka API keys. Requests with API keys matching this list will have
    the connection closed. No effect if empty.
    """


default_message_pool.register_message(
    "envoy.config.filter.network.kafka_broker.v2alpha1", "KafkaBroker", KafkaBroker
)
