# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/data/core/v2alpha/health_check_event.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "HealthCheckerType",
    "HealthCheckFailureType",
    "DegradedHealthyHost",
    "HealthCheckAddHealthy",
    "HealthCheckEjectUnhealthy",
    "HealthCheckEvent",
    "HealthCheckFailure",
    "NoLongerDegradedHost",
)

import datetime
from dataclasses import dataclass

import betterproto2

from .....message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class HealthCheckerType(betterproto2.Enum):
    HTTP = 0

    TCP = 1

    GRPC = 2

    REDIS = 3


class HealthCheckFailureType(betterproto2.Enum):
    """
    [#protodoc-title: Health check logging events]
    :ref:`Health check logging <arch_overview_health_check_logging>`.
    """

    ACTIVE = 0

    PASSIVE = 1

    NETWORK = 2


@dataclass(eq=False, repr=False)
class DegradedHealthyHost(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.data.core.v2alpha", "DegradedHealthyHost", DegradedHealthyHost
)


@dataclass(eq=False, repr=False)
class HealthCheckAddHealthy(betterproto2.Message):
    first_check: "bool" = betterproto2.field(1, betterproto2.TYPE_BOOL)
    """
    Whether this addition is the result of the first ever health check on a host, in which case
    the configured :ref:`healthy threshold <envoy_api_field_core.HealthCheck.healthy_threshold>`
    is bypassed and the host is immediately added.
    """


default_message_pool.register_message(
    "envoy.data.core.v2alpha", "HealthCheckAddHealthy", HealthCheckAddHealthy
)


@dataclass(eq=False, repr=False)
class HealthCheckEjectUnhealthy(betterproto2.Message):
    failure_type: "HealthCheckFailureType" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: HealthCheckFailureType(0)
    )
    """
    The type of failure that caused this ejection.
    """


default_message_pool.register_message(
    "envoy.data.core.v2alpha", "HealthCheckEjectUnhealthy", HealthCheckEjectUnhealthy
)


@dataclass(eq=False, repr=False)
class HealthCheckEvent(betterproto2.Message):
    """
    [#next-free-field: 10]

    Oneofs:
        - event:
    """

    health_checker_type: "HealthCheckerType" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: HealthCheckerType(0)
    )

    host: "___api__v2__core__.Address | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )

    cluster_name: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)

    eject_unhealthy_event: "HealthCheckEjectUnhealthy | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Host ejection.
    """

    add_healthy_event: "HealthCheckAddHealthy | None" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Host addition.
    """

    health_check_failure_event: "HealthCheckFailure | None" = betterproto2.field(
        7, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Host failure.
    """

    degraded_healthy_host: "DegradedHealthyHost | None" = betterproto2.field(
        8, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Healthy host became degraded.
    """

    no_longer_degraded_host: "NoLongerDegradedHost | None" = betterproto2.field(
        9, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    A degraded host returned to being healthy.
    """

    timestamp: "datetime.datetime | None" = betterproto2.field(
        6,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ____google__protobuf__.Timestamp,
        optional=True,
    )
    """
    Timestamp for event.
    """


default_message_pool.register_message(
    "envoy.data.core.v2alpha", "HealthCheckEvent", HealthCheckEvent
)


@dataclass(eq=False, repr=False)
class HealthCheckFailure(betterproto2.Message):
    failure_type: "HealthCheckFailureType" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: HealthCheckFailureType(0)
    )
    """
    The type of failure that caused this event.
    """

    first_check: "bool" = betterproto2.field(2, betterproto2.TYPE_BOOL)
    """
    Whether this event is the result of the first ever health check on a host.
    """


default_message_pool.register_message(
    "envoy.data.core.v2alpha", "HealthCheckFailure", HealthCheckFailure
)


@dataclass(eq=False, repr=False)
class NoLongerDegradedHost(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.data.core.v2alpha", "NoLongerDegradedHost", NoLongerDegradedHost
)


from .....google import protobuf as ____google__protobuf__
from ....api.v2 import core as ___api__v2__core__
