# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/data/core/v3/health_check_event.proto, envoy/data/core/v3/tlv_metadata.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "HealthCheckerType",
    "HealthCheckFailureType",
    "DegradedHealthyHost",
    "HealthCheckAddHealthy",
    "HealthCheckEjectUnhealthy",
    "HealthCheckEvent",
    "HealthCheckFailure",
    "HealthCheckSuccessful",
    "NoLongerDegradedHost",
    "TlvsMetadata",
)

import datetime
from dataclasses import dataclass

import betterproto2

from .....message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class HealthCheckerType(betterproto2.Enum):
    HTTP = 0

    TCP = 1

    GRPC = 2

    REDIS = 3

    THRIFT = 4


class HealthCheckFailureType(betterproto2.Enum):
    """
    [#protodoc-title: Health check logging events]
    :ref:`Health check logging <arch_overview_health_check_logging>`.
    """

    ACTIVE = 0

    PASSIVE = 1

    NETWORK = 2

    NETWORK_TIMEOUT = 3


@dataclass(eq=False, repr=False)
class DegradedHealthyHost(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.data.core.v3", "DegradedHealthyHost", DegradedHealthyHost
)


@dataclass(eq=False, repr=False)
class HealthCheckAddHealthy(betterproto2.Message):
    first_check: "bool" = betterproto2.field(1, betterproto2.TYPE_BOOL)
    """
    Whether this addition is the result of the first ever health check on a host, in which case
    the configured :ref:`healthy threshold <envoy_v3_api_field_config.core.v3.HealthCheck.healthy_threshold>`
    is bypassed and the host is immediately added.
    """


default_message_pool.register_message(
    "envoy.data.core.v3", "HealthCheckAddHealthy", HealthCheckAddHealthy
)


@dataclass(eq=False, repr=False)
class HealthCheckEjectUnhealthy(betterproto2.Message):
    failure_type: "HealthCheckFailureType" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: HealthCheckFailureType(0)
    )
    """
    The type of failure that caused this ejection.
    """


default_message_pool.register_message(
    "envoy.data.core.v3", "HealthCheckEjectUnhealthy", HealthCheckEjectUnhealthy
)


@dataclass(eq=False, repr=False)
class HealthCheckEvent(betterproto2.Message):
    """
    [#next-free-field: 13]

    Oneofs:
        - event:
    """

    health_checker_type: "HealthCheckerType" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: HealthCheckerType(0)
    )

    host: "___config__core__v3__.Address | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )

    cluster_name: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)

    eject_unhealthy_event: "HealthCheckEjectUnhealthy | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Host ejection.
    """

    add_healthy_event: "HealthCheckAddHealthy | None" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Host addition.
    """

    successful_health_check_event: "HealthCheckSuccessful | None" = betterproto2.field(
        12, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    A health check was successful. Note: a host will be considered healthy either if it is
    the first ever health check, or if the healthy threshold is reached. This kind of event
    indicate that a health check was successful, but does not indicates that the host is
    considered healthy. A host is considered healthy if HealthCheckAddHealthy kind of event is sent.
    """

    health_check_failure_event: "HealthCheckFailure | None" = betterproto2.field(
        7, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Host failure.
    """

    degraded_healthy_host: "DegradedHealthyHost | None" = betterproto2.field(
        8, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    Healthy host became degraded.
    """

    no_longer_degraded_host: "NoLongerDegradedHost | None" = betterproto2.field(
        9, betterproto2.TYPE_MESSAGE, optional=True, group="event"
    )
    """
    A degraded host returned to being healthy.
    """

    timestamp: "datetime.datetime | None" = betterproto2.field(
        6,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ____google__protobuf__.Timestamp,
        optional=True,
    )
    """
    Timestamp for event.
    """

    metadata: "___config__core__v3__.Metadata | None" = betterproto2.field(
        10, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Host metadata
    """

    locality: "___config__core__v3__.Locality | None" = betterproto2.field(
        11, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Host locality
    """


default_message_pool.register_message(
    "envoy.data.core.v3", "HealthCheckEvent", HealthCheckEvent
)


@dataclass(eq=False, repr=False)
class HealthCheckFailure(betterproto2.Message):
    failure_type: "HealthCheckFailureType" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: HealthCheckFailureType(0)
    )
    """
    The type of failure that caused this event.
    """

    first_check: "bool" = betterproto2.field(2, betterproto2.TYPE_BOOL)
    """
    Whether this event is the result of the first ever health check on a host.
    """


default_message_pool.register_message(
    "envoy.data.core.v3", "HealthCheckFailure", HealthCheckFailure
)


@dataclass(eq=False, repr=False)
class HealthCheckSuccessful(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.data.core.v3", "HealthCheckSuccessful", HealthCheckSuccessful
)


@dataclass(eq=False, repr=False)
class NoLongerDegradedHost(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.data.core.v3", "NoLongerDegradedHost", NoLongerDegradedHost
)


@dataclass(eq=False, repr=False)
class TlvsMetadata(betterproto2.Message):
    """
    [#protodoc-title: Proxy Protocol Filter Typed Metadata]
    PROXY protocol filter typed metadata.
    """

    typed_metadata: "dict[str, bytes]" = betterproto2.field(
        1,
        betterproto2.TYPE_MAP,
        map_meta=betterproto2.map_meta(
            betterproto2.TYPE_STRING, betterproto2.TYPE_BYTES
        ),
    )
    """
    Typed metadata for :ref:`Proxy protocol filter <envoy_v3_api_msg_extensions.filters.listener.proxy_protocol.v3.ProxyProtocol>`, that represents a map of TLVs.
    Each entry in the map consists of a key which corresponds to a configured
    :ref:`rule key <envoy_v3_api_field_extensions.filters.listener.proxy_protocol.v3.ProxyProtocol.KeyValuePair.key>` and a value (TLV value in bytes).
    When runtime flag ``envoy.reloadable_features.use_typed_metadata_in_proxy_protocol_listener`` is enabled,
    :ref:`Proxy protocol filter <envoy_v3_api_msg_extensions.filters.listener.proxy_protocol.v3.ProxyProtocol>`
    will populate typed metadata and regular metadata. By default filter will populate typed and untyped metadata.
    """


default_message_pool.register_message(
    "envoy.data.core.v3", "TlvsMetadata", TlvsMetadata
)


from .....google import protobuf as ____google__protobuf__
from ....config.core import v3 as ___config__core__v3__
