# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/access_loggers/fluentd/v3/fluentd.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "FluentdAccessLogConfig",
    "FluentdAccessLogConfigRetryOptions",
)

import datetime
from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class FluentdAccessLogConfig(betterproto2.Message):
    """
    [#protodoc-title: Fluentd access log]

    Configuration for the *envoy.access_loggers.fluentd* :ref:`AccessLog <envoy_v3_api_msg_config.accesslog.v3.AccessLog>`.
    This access log extension will send the emitted access logs over a TCP connection to an upstream that is accepting
    the Fluentd Forward Protocol as described in: `Fluentd Forward Protocol Specification
    <https://github.com/fluent/fluentd/wiki/Forward-Protocol-Specification-v1>`_.
    [#extension: envoy.access_loggers.fluentd]
    [#next-free-field: 9]
    """

    cluster: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The upstream cluster to connect to for streaming the Fluentd messages.
    """

    tag: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    A tag is a string separated with '.' (e.g. log.type) to categorize events.
    See: https://github.com/fluent/fluentd/wiki/Forward-Protocol-Specification-v1#message-modes
    """

    stat_prefix: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    The prefix to use when emitting :ref:`statistics <config_access_log_stats>`.
    """

    buffer_flush_interval: "datetime.timedelta | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.Duration,
        optional=True,
    )
    """
    Interval for flushing access logs to the TCP stream. Logger will flush requests every time
    this interval is elapsed, or when batch size limit is hit, whichever comes first. Defaults to
    1 second.
    """

    buffer_size_bytes: "int | None" = betterproto2.field(
        5,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    Soft size limit in bytes for access log entries buffer. The logger will buffer requests until
    this limit it hit, or every time flush interval is elapsed, whichever comes first. When the buffer
    limit is hit, the logger will immediately flush the buffer contents. Setting it to zero effectively
    disables the batching. Defaults to 16384.
    """

    record: "_____google__protobuf__.Struct | None" = betterproto2.field(
        6, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    A struct that represents the record that is sent for each log entry.
    https://github.com/fluent/fluentd/wiki/Forward-Protocol-Specification-v1#entry
    Values are rendered as strings, numbers, or boolean values as appropriate.
    Nested JSON objects may be produced by some command operators (e.g. FILTER_STATE or DYNAMIC_METADATA).
    See :ref:`format string<config_access_log_format_strings>` documentation for a specific command operator details.

    .. validated-code-block:: yaml
      :type-name: envoy.extensions.access_loggers.fluentd.v3.FluentdAccessLogConfig

      record:
        status: "%RESPONSE_CODE%"
        message: "%LOCAL_REPLY_BODY%"

    The following msgpack record would be created:

    .. code-block:: json

     {
       "status": 500,
       "message": "My error message"
     }
    """

    retry_options: "FluentdAccessLogConfigRetryOptions | None" = betterproto2.field(
        7, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Optional retry, in case upstream connection has failed. If this field is not set, the default values will be applied,
    as specified in the :ref:`RetryOptions <envoy_v3_api_msg_extensions.access_loggers.fluentd.v3.FluentdAccessLogConfig.RetryOptions>`
    configuration.
    """

    formatters: "list[____config__core__v3__.TypedExtensionConfig]" = (
        betterproto2.field(8, betterproto2.TYPE_MESSAGE, repeated=True)
    )
    """
    Specifies a collection of Formatter plugins that can be called from the access log configuration.
    See the formatters extensions documentation for details.
    [#extension-category: envoy.formatter]
    """


default_message_pool.register_message(
    "envoy.extensions.access_loggers.fluentd.v3",
    "FluentdAccessLogConfig",
    FluentdAccessLogConfig,
)


@dataclass(eq=False, repr=False)
class FluentdAccessLogConfigRetryOptions(betterproto2.Message):
    max_connect_attempts: "int | None" = betterproto2.field(
        1,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The number of times the logger will attempt to connect to the upstream during reconnects.
    By default, there is no limit. The logger will attempt to reconnect to the upstream each time
    connecting to the upstream failed or the upstream connection had been closed for any reason.
    """

    backoff_options: "____config__core__v3__.BackoffStrategy | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Sets the backoff strategy. If this value is not set, the default base backoff interval is 500
    milliseconds and the default max backoff interval is 5 seconds (10 times the base interval).
    """


default_message_pool.register_message(
    "envoy.extensions.access_loggers.fluentd.v3",
    "FluentdAccessLogConfig.RetryOptions",
    FluentdAccessLogConfigRetryOptions,
)


from ......google import protobuf as _____google__protobuf__
from .....config.core import v3 as ____config__core__v3__
