# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/clusters/dynamic_forward_proxy/v3/cluster.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "ClusterConfig",
    "SubClustersConfig",
)

import datetime
from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class ClusterConfig(betterproto2.Message):
    """
    [#protodoc-title: Dynamic forward proxy cluster configuration]

    Configuration for the dynamic forward proxy cluster. See the :ref:`architecture overview
    <arch_overview_http_dynamic_forward_proxy>` for more information.
    [#extension: envoy.clusters.dynamic_forward_proxy]

    Oneofs:
        - cluster_implementation_specifier:
    """

    dns_cache_config: "___common__dynamic_forward_proxy__v3__.DnsCacheConfig | None" = (
        betterproto2.field(
            1,
            betterproto2.TYPE_MESSAGE,
            optional=True,
            group="cluster_implementation_specifier",
        )
    )
    """
    The DNS cache configuration that the cluster will attach to. Note this configuration must
    match that of associated :ref:`dynamic forward proxy HTTP filter configuration
    <envoy_v3_api_field_extensions.filters.http.dynamic_forward_proxy.v3.FilterConfig.dns_cache_config>`.
    """

    sub_clusters_config: "SubClustersConfig | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        optional=True,
        group="cluster_implementation_specifier",
    )
    """
    Configuration for sub clusters, when this configuration is enabled,
    Envoy will create an independent sub cluster dynamically for each host:port.
    Most of the configuration of a sub cluster is inherited from the current cluster,
    i.e. health_checks, dns_resolvers and etc.
    And the load_assignment will be set to the only one endpoint, host:port.

    Compared to the dns_cache_config, it has the following advantages:

    1. sub clusters will be created with the STRICT_DNS DiscoveryType,
       so that Envoy will use all of the IPs resolved from the host.

    2. each sub cluster is full featured cluster, with lb_policy and health check and etc enabled.
    """

    allow_insecure_cluster_options: "bool" = betterproto2.field(
        2, betterproto2.TYPE_BOOL
    )
    """
    If true allow the cluster configuration to disable the auto_sni and auto_san_validation options
    in the :ref:`cluster's upstream_http_protocol_options
    <envoy_v3_api_field_config.cluster.v3.Cluster.upstream_http_protocol_options>`
    """

    allow_coalesced_connections: "bool" = betterproto2.field(3, betterproto2.TYPE_BOOL)
    """
    If true allow HTTP/2 and HTTP/3 connections to be reused for requests to different
    origins than the connection was initially created for. This will only happen when the
    resolved address for the new connection matches the peer address of the connection and
    the TLS certificate is also valid for the new hostname. For example, if a connection
    has previously been established to foo.example.com at IP 1.2.3.4 with a certificate
    that is valid for ``*.example.com``, then this connection could be used for requests to
    bar.example.com if that also resolved to 1.2.3.4.

    .. note::
      By design, this feature will maximize reuse of connections. This means that instead
      opening a new connection when an existing connection reaches the maximum number of
      concurrent streams, requests will instead be sent to the existing connection.

    .. note::
      The coalesced connections might be to upstreams that would not be otherwise
      selected by Envoy. See the section `Connection Reuse in RFC 7540
      <https://datatracker.ietf.org/doc/html/rfc7540#section-9.1.1>`_
    """


default_message_pool.register_message(
    "envoy.extensions.clusters.dynamic_forward_proxy.v3", "ClusterConfig", ClusterConfig
)


@dataclass(eq=False, repr=False)
class SubClustersConfig(betterproto2.Message):
    """
    Configuration for sub clusters. Hard code STRICT_DNS cluster type now.
    """

    lb_policy: "____config__cluster__v3__.ClusterLbPolicy" = betterproto2.field(
        1,
        betterproto2.TYPE_ENUM,
        default_factory=lambda: ____config__cluster__v3__.ClusterLbPolicy(0),
    )
    """
    The :ref:`load balancer type <arch_overview_load_balancing_types>` to use
    when picking a host in a sub cluster. Note that CLUSTER_PROVIDED is not allowed here.
    """

    max_sub_clusters: "int | None" = betterproto2.field(
        2,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The maximum number of sub clusters that the DFP cluster will hold. If not specified defaults to 1024.
    """

    sub_cluster_ttl: "datetime.timedelta | None" = betterproto2.field(
        3,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.Duration,
        optional=True,
    )
    """
    The TTL for sub clusters that are unused. Sub clusters that have not been used in the configured time
    interval will be purged. If not specified defaults to 5m.
    """

    preresolve_clusters: "list[____config__core__v3__.SocketAddress]" = (
        betterproto2.field(4, betterproto2.TYPE_MESSAGE, repeated=True)
    )
    """
    Sub clusters that should be created & warmed upon creation. This might provide a
    performance improvement, in the form of cache hits, for sub clusters that are going to be
    warmed during steady state and are known at config load time.
    """


default_message_pool.register_message(
    "envoy.extensions.clusters.dynamic_forward_proxy.v3",
    "SubClustersConfig",
    SubClustersConfig,
)


from ......google import protobuf as _____google__protobuf__
from .....config.cluster import v3 as ____config__cluster__v3__
from .....config.core import v3 as ____config__core__v3__
from ....common.dynamic_forward_proxy import (
    v3 as ___common__dynamic_forward_proxy__v3__,
)
