# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/common/aws/v3/credential_provider.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "AssumeRoleWithWebIdentityCredentialProvider",
    "AwsCredentialProvider",
    "CredentialsFileCredentialProvider",
    "InlineCredentialProvider",
)

from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class AssumeRoleWithWebIdentityCredentialProvider(betterproto2.Message):
    """
    Configuration to use `AssumeRoleWithWebIdentity <https://docs.aws.amazon.com/STS/latest/APIReference/API_AssumeRoleWithWebIdentity.html>`_
    to retrieve AWS credentials.
    """

    web_identity_token_data_source: "____config__core__v3__.DataSource | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Data source for a web identity token that is provided by the identity provider to assume the role.
    When using this data source, even if a ``watched_directory`` is provided, the token file will only be re-read when the credentials
    returned from AssumeRoleWithWebIdentity expire.
    """

    role_arn: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The ARN of the role to assume.
    """

    role_session_name: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    Optional role session name to use in AssumeRoleWithWebIdentity API call.
    """


default_message_pool.register_message(
    "envoy.extensions.common.aws.v3",
    "AssumeRoleWithWebIdentityCredentialProvider",
    AssumeRoleWithWebIdentityCredentialProvider,
)


@dataclass(eq=False, repr=False)
class AwsCredentialProvider(betterproto2.Message):
    """
    [#protodoc-title: AWS common configuration]

    Configuration for AWS credential provider. This is optional and the credentials are normally
    retrieved from the environment or AWS configuration files by following the default credential
    provider chain. However, this configuration can be used to override the default behavior.
    """

    assume_role_with_web_identity_provider: "AssumeRoleWithWebIdentityCredentialProvider | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The option to use `AssumeRoleWithWebIdentity <https://docs.aws.amazon.com/STS/latest/APIReference/API_AssumeRoleWithWebIdentity.html>`_.
    """

    inline_credential: "InlineCredentialProvider | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The option to use an inline credential. If inline credential is provided, no chain will be created and only the inline credential will be used.
    """

    credentials_file_provider: "CredentialsFileCredentialProvider | None" = (
        betterproto2.field(3, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The option to specify parameters for credential retrieval from an envoy data source, such as a file in AWS credential format.
    """

    custom_credential_provider_chain: "bool" = betterproto2.field(
        4, betterproto2.TYPE_BOOL
    )
    """
    Create a custom credential provider chain instead of the default credential provider chain.
    If set to TRUE, the credential provider chain that is created contains only those set in this credential provider message.
    If set to FALSE, the settings provided here will act as modifiers to the default credential provider chain.
    Defaults to FALSE.

    This has no effect if inline_credential is provided.
    """


default_message_pool.register_message(
    "envoy.extensions.common.aws.v3", "AwsCredentialProvider", AwsCredentialProvider
)


@dataclass(eq=False, repr=False)
class CredentialsFileCredentialProvider(betterproto2.Message):
    credentials_data_source: "____config__core__v3__.DataSource | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Data source from which to retrieve AWS credentials
    When using this data source, if a ``watched_directory`` is provided, the credential file will be re-read when a file move is detected.
    See :ref:`watched_directory <envoy_v3_api_msg_config.core.v3.DataSource>` for more information about the ``watched_directory`` field.
    """

    profile: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The profile within the credentials_file data source. If not provided, the default profile will be used.
    """


default_message_pool.register_message(
    "envoy.extensions.common.aws.v3",
    "CredentialsFileCredentialProvider",
    CredentialsFileCredentialProvider,
)


@dataclass(eq=False, repr=False)
class InlineCredentialProvider(betterproto2.Message):
    """
    Configuration to use an inline AWS credential. This is an equivalent to setting the well-known
    environment variables ``AWS_ACCESS_KEY_ID``, ``AWS_SECRET_ACCESS_KEY``, and the optional ``AWS_SESSION_TOKEN``.
    """

    access_key_id: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The AWS access key ID.
    """

    secret_access_key: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The AWS secret access key.
    """

    session_token: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    The AWS session token. This is optional.
    """


default_message_pool.register_message(
    "envoy.extensions.common.aws.v3",
    "InlineCredentialProvider",
    InlineCredentialProvider,
)


from .....config.core import v3 as ____config__core__v3__
