# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/common/fault/v3/fault.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "FaultDelayFaultDelayType",
    "FaultDelay",
    "FaultDelayHeaderDelay",
    "FaultRateLimit",
    "FaultRateLimitFixedLimit",
    "FaultRateLimitHeaderLimit",
)

import datetime
from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class FaultDelayFaultDelayType(betterproto2.Enum):
    FIXED = 0
    """
    Unused and deprecated.
    """


@dataclass(eq=False, repr=False)
class FaultDelay(betterproto2.Message):
    """
    [#protodoc-title: Common fault injection types]

    Delay specification is used to inject latency into the
    HTTP/Mongo operation.
    [#next-free-field: 6]

    Oneofs:
        - fault_delay_secifier:
    """

    fixed_delay: "datetime.timedelta | None" = betterproto2.field(
        3,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
        group="fault_delay_secifier",
    )
    """
    Add a fixed delay before forwarding the operation upstream. See
    https://developers.google.com/protocol-buffers/docs/proto3#json for
    the JSON/YAML Duration mapping. For HTTP/Mongo, the specified
    delay will be injected before a new request/operation.
    This is required if type is FIXED.
    """

    header_delay: "FaultDelayHeaderDelay | None" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, optional=True, group="fault_delay_secifier"
    )
    """
    Fault delays are controlled via an HTTP header (if applicable).
    """

    percentage: "_____type__v3__.FractionalPercent | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The percentage of operations/connections/requests on which the delay will be injected.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.common.fault.v3", "FaultDelay", FaultDelay
)


@dataclass(eq=False, repr=False)
class FaultDelayHeaderDelay(betterproto2.Message):
    """
    Fault delays are controlled via an HTTP header (if applicable). See the
    :ref:`HTTP fault filter <config_http_filters_fault_injection_http_header>` documentation for
    more information.
    """

    pass


default_message_pool.register_message(
    "envoy.extensions.filters.common.fault.v3",
    "FaultDelay.HeaderDelay",
    FaultDelayHeaderDelay,
)


@dataclass(eq=False, repr=False)
class FaultRateLimit(betterproto2.Message):
    """
    Describes a rate limit to be applied.

    Oneofs:
        - limit_type:
    """

    fixed_limit: "FaultRateLimitFixedLimit | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True, group="limit_type"
    )
    """
    A fixed rate limit.
    """

    header_limit: "FaultRateLimitHeaderLimit | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True, group="limit_type"
    )
    """
    Rate limits are controlled via an HTTP header (if applicable).
    """

    percentage: "_____type__v3__.FractionalPercent | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The percentage of operations/connections/requests on which the rate limit will be injected.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.common.fault.v3", "FaultRateLimit", FaultRateLimit
)


@dataclass(eq=False, repr=False)
class FaultRateLimitFixedLimit(betterproto2.Message):
    """
    Describes a fixed/constant rate limit.
    """

    limit_kbps: "int" = betterproto2.field(1, betterproto2.TYPE_UINT64)
    """
    The limit supplied in KiB/s.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.common.fault.v3",
    "FaultRateLimit.FixedLimit",
    FaultRateLimitFixedLimit,
)


@dataclass(eq=False, repr=False)
class FaultRateLimitHeaderLimit(betterproto2.Message):
    """
    Rate limits are controlled via an HTTP header (if applicable). See the
    :ref:`HTTP fault filter <config_http_filters_fault_injection_http_header>` documentation for
    more information.
    """

    pass


default_message_pool.register_message(
    "envoy.extensions.filters.common.fault.v3",
    "FaultRateLimit.HeaderLimit",
    FaultRateLimitHeaderLimit,
)


from .......google import protobuf as ______google__protobuf__
from ......type import v3 as _____type__v3__
