# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/common/set_filter_state/v3/value.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "FilterStateValueSharedWithUpstream",
    "FilterStateValue",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class FilterStateValueSharedWithUpstream(betterproto2.Enum):
    NONE = 0
    """
    Object is not shared with the upstream internal connections.
    """

    ONCE = 1
    """
    Object is shared with the upstream internal connection.
    """

    TRANSITIVE = 2
    """
    Object is shared with the upstream internal connection and any internal connection upstream from it.
    """


@dataclass(eq=False, repr=False)
class FilterStateValue(betterproto2.Message):
    """
    [#protodoc-title: Set-Filter-State filter state value]

    A filter state key and value pair.
    [#next-free-field: 7]

    Oneofs:
        - key:
        - value:
    """

    object_key: "str | None" = betterproto2.field(
        1, betterproto2.TYPE_STRING, optional=True, group="key"
    )
    """
    Filter state object key. The key is used to lookup the object factory, unless :ref:`factory_key
    <envoy_v3_api_field_extensions.filters.common.set_filter_state.v3.FilterStateValue.factory_key>` is set. See
    :ref:`the well-known filter state keys <well_known_filter_state>` for a list of valid object keys.
    """

    factory_key: "str" = betterproto2.field(6, betterproto2.TYPE_STRING)
    """
    Optional filter object factory lookup key. See :ref:`the well-known filter state keys <well_known_filter_state>`
    for a list of valid factory keys.
    """

    format_string: "_____config__core__v3__.SubstitutionFormatString | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True, group="value")
    )
    """
    Uses the :ref:`format string <config_access_log_format_strings>` to
    instantiate the filter state object value.
    """

    read_only: "bool" = betterproto2.field(3, betterproto2.TYPE_BOOL)
    """
    If marked as read-only, the filter state key value is locked, and cannot
    be overridden by any filter, including this filter.
    """

    shared_with_upstream: "FilterStateValueSharedWithUpstream" = betterproto2.field(
        4,
        betterproto2.TYPE_ENUM,
        default_factory=lambda: FilterStateValueSharedWithUpstream(0),
    )
    """
    Configures the object to be shared with the upstream internal connections. See :ref:`internal upstream
    transport <config_internal_upstream_transport>` for more details on the filter state sharing with
    the internal connections.
    """

    skip_if_empty: "bool" = betterproto2.field(5, betterproto2.TYPE_BOOL)
    """
    Skip the update if the value evaluates to an empty string.
    This option can be used to supply multiple alternatives for the same filter state object key.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.common.set_filter_state.v3",
    "FilterStateValue",
    FilterStateValue,
)


from ......config.core import v3 as _____config__core__v3__
