# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/api_key_auth/v3/api_key_auth.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "ApiKeyAuth",
    "ApiKeyAuthPerRoute",
    "Credential",
    "KeySource",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class ApiKeyAuth(betterproto2.Message):
    """
    [#protodoc-title: APIKey Auth]
    APIKey Auth :ref:`configuration overview <config_http_filters_api_key_auth>`.
    [#extension: envoy.filters.http.api_key_auth]

    API Key HTTP authentication.

    For example, the following configuration configures the filter to authenticate the clients using
    the API key from the header ``X-API-KEY``. And only the clients with the key ``real-key`` are
    considered as authenticated.

    .. code-block:: yaml

       credentials:
       - key: real-key
         client: user
       key_sources:
        - header: "X-API-KEY"
    """

    credentials: "list[Credential]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    The credentials that are used to authenticate the clients.
    """

    key_sources: "list[KeySource]" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    The key sources to fetch the key from the coming request.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.api_key_auth.v3", "ApiKeyAuth", ApiKeyAuth
)


@dataclass(eq=False, repr=False)
class ApiKeyAuthPerRoute(betterproto2.Message):
    """
    API key auth configuration of per route or per virtual host or per route configuration.
    """

    credentials: "list[Credential]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    The credentials that are used to authenticate the clients. If this field is non-empty, then the
    credentials in the filter level configuration will be ignored and the credentials in this
    configuration will be used.
    """

    key_sources: "list[KeySource]" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    The key sources to fetch the key from the coming request. If this field is non-empty, then the
    key sources in the filter level configuration will be ignored and the key sources in this
    configuration will be used.
    """

    allowed_clients: "list[str]" = betterproto2.field(
        3, betterproto2.TYPE_STRING, repeated=True
    )
    """
    A list of clients that are allowed to access the route or vhost. The clients listed here
    should be subset of the clients listed in the ``credentials`` to provide authorization control
    after the authentication is successful. If the list is empty, then all authenticated clients
    are allowed. This provides very limited but simple authorization. If more complex authorization
    is required, then use the :ref:`HTTP RBAC filter <config_http_filters_rbac>` instead.

    .. note::
      Setting this field and ``credentials`` at the same configuration entry is not an error but
      also makes no much sense because they provide similar functionality. Please only use
      one of them at same configuration entry except for the case that you want to share the same
      credentials list across multiple routes but still use different allowed clients for each
      route.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.api_key_auth.v3",
    "ApiKeyAuthPerRoute",
    ApiKeyAuthPerRoute,
)


@dataclass(eq=False, repr=False)
class Credential(betterproto2.Message):
    """
    Single credential entry that contains the API key and the related client id.
    """

    key: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The value of the unique API key.
    """

    client: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The unique id or identity that used to identify the client or consumer.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.api_key_auth.v3", "Credential", Credential
)


@dataclass(eq=False, repr=False)
class KeySource(betterproto2.Message):
    header: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The header name to fetch the key. If multiple header values are present, the first one will be
    used. If the header value starts with 'Bearer ', this prefix will be stripped to get the
    key value.

    If set, takes precedence over ``query`` and ``cookie``.
    """

    query: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The query parameter name to fetch the key. If multiple query values are present, the first one
    will be used.

    The field will be used if ``header`` is not set. If set, takes precedence over ``cookie``.
    """

    cookie: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    The cookie name to fetch the key.

    The field will be used if the ``header`` and ``query`` are not set.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.api_key_auth.v3", "KeySource", KeySource
)
