# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/csrf/v3/csrf.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("CsrfPolicy",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class CsrfPolicy(betterproto2.Message):
    """
    [#protodoc-title: CSRF]
    Cross-Site Request Forgery :ref:`configuration overview <config_http_filters_csrf>`.
    [#extension: envoy.filters.http.csrf]

    CSRF filter config.
    """

    filter_enabled: "_____config__core__v3__.RuntimeFractionalPercent | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Specifies the % of requests for which the CSRF filter is enabled.

    If :ref:`runtime_key <envoy_v3_api_field_config.core.v3.RuntimeFractionalPercent.runtime_key>` is specified,
    Envoy will lookup the runtime key to get the percentage of requests to filter.

    .. note::

      This field defaults to 100/:ref:`HUNDRED
      <envoy_v3_api_enum_type.v3.FractionalPercent.DenominatorType>`.
    """

    shadow_enabled: "_____config__core__v3__.RuntimeFractionalPercent | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Specifies that CSRF policies will be evaluated and tracked, but not enforced.

    This is intended to be used when ``filter_enabled`` is off and will be ignored otherwise.

    If :ref:`runtime_key <envoy_v3_api_field_config.core.v3.RuntimeFractionalPercent.runtime_key>` is specified,
    Envoy will lookup the runtime key to get the percentage of requests for which it will evaluate
    and track the request's ``Origin`` and ``Destination`` to determine if it's valid, but will not
    enforce any policies.
    """

    additional_origins: "list[_____type__matcher__v3__.StringMatcher]" = (
        betterproto2.field(3, betterproto2.TYPE_MESSAGE, repeated=True)
    )
    """
    Specifies additional source origins that will be allowed in addition to
    the destination origin.

    More information on how this can be configured via runtime can be found
    :ref:`here <csrf-configuration>`.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.csrf.v3", "CsrfPolicy", CsrfPolicy
)


from ......config.core import v3 as _____config__core__v3__
from ......type.matcher import v3 as _____type__matcher__v3__
