# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/decompressor/v3/decompressor.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "Decompressor",
    "DecompressorCommonDirectionConfig",
    "DecompressorRequestDirectionConfig",
    "DecompressorResponseDirectionConfig",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class Decompressor(betterproto2.Message):
    """
    [#protodoc-title: Decompressor]
    [#extension: envoy.filters.http.decompressor]
    """

    decompressor_library: "_____config__core__v3__.TypedExtensionConfig | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    A decompressor library to use for both request and response decompression. Currently only
    :ref:`envoy.compression.gzip.compressor<envoy_v3_api_msg_extensions.compression.gzip.decompressor.v3.Gzip>`
    is included in Envoy.
    [#extension-category: envoy.compression.decompressor]
    """

    request_direction_config: "DecompressorRequestDirectionConfig | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration for request decompression. Decompression is enabled by default if left empty.
    """

    response_direction_config: "DecompressorResponseDirectionConfig | None" = (
        betterproto2.field(3, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration for response decompression. Decompression is enabled by default if left empty.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.decompressor.v3", "Decompressor", Decompressor
)


@dataclass(eq=False, repr=False)
class DecompressorCommonDirectionConfig(betterproto2.Message):
    """
    Common configuration for filter behavior on both the request and response direction.
    """

    enabled: "_____config__core__v3__.RuntimeFeatureFlag | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Runtime flag that controls whether the filter is enabled for decompression or not. If set to false, the
    filter will operate as a pass-through filter. If the message is unspecified, the filter will be enabled.
    """

    ignore_no_transform_header: "bool" = betterproto2.field(2, betterproto2.TYPE_BOOL)
    """
    If set to true, will decompress response even if a ``no-transform`` cache control header is set.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.decompressor.v3",
    "Decompressor.CommonDirectionConfig",
    DecompressorCommonDirectionConfig,
)


@dataclass(eq=False, repr=False)
class DecompressorRequestDirectionConfig(betterproto2.Message):
    """
    Configuration for filter behavior on the request direction.
    """

    common_config: "DecompressorCommonDirectionConfig | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )

    advertise_accept_encoding: "bool | None" = betterproto2.field(
        2,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.BoolValue,
        optional=True,
    )
    """
    If set to true, and response decompression is enabled, the filter modifies the Accept-Encoding
    request header by appending the decompressor_library's encoding. Defaults to true.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.decompressor.v3",
    "Decompressor.RequestDirectionConfig",
    DecompressorRequestDirectionConfig,
)


@dataclass(eq=False, repr=False)
class DecompressorResponseDirectionConfig(betterproto2.Message):
    """
    Configuration for filter behavior on the response direction.
    """

    common_config: "DecompressorCommonDirectionConfig | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )


default_message_pool.register_message(
    "envoy.extensions.filters.http.decompressor.v3",
    "Decompressor.ResponseDirectionConfig",
    DecompressorResponseDirectionConfig,
)


from .......google import protobuf as ______google__protobuf__
from ......config.core import v3 as _____config__core__v3__
