# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/grpc_json_reverse_transcoder/v3/transcoder.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("GrpcJsonReverseTranscoder",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class GrpcJsonReverseTranscoder(betterproto2.Message):
    """
    [#protodoc-title: gRPC-JSON reverse transcoder]
    gRPC-JSON reverse transcoder :ref:`configuration overview <config_http_filters_grpc_json_reverse_transcoder>`.
    [#extension: envoy.filters.http.grpc_json_reverse_transcoder]

    [#next-free-field: 6]
    ``GrpcJsonReverseTranscoder`` is the filter configuration for the gRPC JSON
    reverse transcoder. The reverse transcoder acts as a bridge between a gRPC
    client and an HTTP/JSON server, converting the gRPC request into HTTP/JSON
    for the HTTP backend and the HTTP/JSON response back to gRPC for the gRPC
    client. This effectively reverses the behavior of the
    :ref:`grpc_json_transcoder filter <config_http_filters_grpc_json_transcoder>`,
    allowing a gRPC client to communicate with an HTTP/JSON server.
    """

    descriptor_path: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    Supplies the filename of
    :ref:`the proto descriptor set
    <config_grpc_json_reverse_transcoder_generate_proto_descriptor_set>` for the gRPC services.
    If set, takes precedence over the ``descriptor_binary`` field.
    """

    descriptor_binary: "bytes" = betterproto2.field(2, betterproto2.TYPE_BYTES)
    """
    Supplies the binary content of
    :ref:`the proto descriptor set
    <config_grpc_json_reverse_transcoder_generate_proto_descriptor_set>` for the gRPC services.
    If ``descriptor_path`` is set, this field is not used.
    """

    max_request_body_size: "int | None" = betterproto2.field(
        3,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The maximum size of a request body to be transcoded, in bytes. A body exceeding this size will
    provoke a ``gRPC status: ResourceExhausted`` response.

    Large values may cause envoy to use a lot of memory if there are many
    concurrent requests.

    If unset, the current stream buffer size is used.
    """

    max_response_body_size: "int | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The maximum size of a response body to be transcoded, in bytes. A body exceeding this size will
    provoke a ``gRPC status: Internal`` response.

    Large values may cause envoy to use a lot of memory if there are many
    concurrent requests.

    If unset, the current stream buffer size is used.
    """

    api_version_header: "str" = betterproto2.field(5, betterproto2.TYPE_STRING)
    """
    The name of the header field that has the API version of the request.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.grpc_json_reverse_transcoder.v3",
    "GrpcJsonReverseTranscoder",
    GrpcJsonReverseTranscoder,
)


from .......google import protobuf as ______google__protobuf__
