# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/gzip/v3/gzip.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "GzipCompressionLevelEnum",
    "GzipCompressionStrategy",
    "Gzip",
    "GzipCompressionLevel",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class GzipCompressionLevelEnum(betterproto2.Enum):
    DEFAULT = 0

    BEST = 1

    SPEED = 2


class GzipCompressionStrategy(betterproto2.Enum):
    DEFAULT = 0

    FILTERED = 1

    HUFFMAN = 2

    RLE = 3


@dataclass(eq=False, repr=False)
class Gzip(betterproto2.Message):
    """
    [#protodoc-title: Gzip]

    [#next-free-field: 12]
    """

    memory_level: "int | None" = betterproto2.field(
        1,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    Value from 1 to 9 that controls the amount of internal memory used by zlib. Higher values
    use more memory, but are faster and produce better compression results. The default value is 5.
    """

    compression_level: "GzipCompressionLevelEnum" = betterproto2.field(
        3, betterproto2.TYPE_ENUM, default_factory=lambda: GzipCompressionLevelEnum(0)
    )
    """
    A value used for selecting the zlib compression level. This setting will affect speed and
    amount of compression applied to the content. "BEST" provides higher compression at the cost of
    higher latency, "SPEED" provides lower compression with minimum impact on response time.
    "DEFAULT" provides an optimal result between speed and compression. This field will be set to
    "DEFAULT" if not specified.
    """

    compression_strategy: "GzipCompressionStrategy" = betterproto2.field(
        4, betterproto2.TYPE_ENUM, default_factory=lambda: GzipCompressionStrategy(0)
    )
    """
    A value used for selecting the zlib compression strategy which is directly related to the
    characteristics of the content. Most of the time "DEFAULT" will be the best choice, though
    there are situations which changing this parameter might produce better results. For example,
    run-length encoding (RLE) is typically used when the content is known for having sequences
    which same data occurs many consecutive times. For more information about each strategy, please
    refer to zlib manual.
    """

    window_bits: "int | None" = betterproto2.field(
        9,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    Value from 9 to 15 that represents the base two logarithmic of the compressor's window size.
    Larger window results in better compression at the expense of memory usage. The default is 12
    which will produce a 4096 bytes window. For more details about this parameter, please refer to
    zlib manual > deflateInit2.
    """

    compressor: "__compressor__v3__.Compressor | None" = betterproto2.field(
        10, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Set of configuration parameters common for all compression filters. You can define
    ``content_length``, ``content_type`` and other parameters in this field.
    """

    chunk_size: "int | None" = betterproto2.field(
        11,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    Value for Zlib's next output buffer. If not set, defaults to 4096.
    See https://www.zlib.net/manual.html for more details. Also see
    https://github.com/envoyproxy/envoy/issues/8448 for context on this filter's performance.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.gzip.v3", "Gzip", Gzip
)


@dataclass(eq=False, repr=False)
class GzipCompressionLevel(betterproto2.Message):
    pass


default_message_pool.register_message(
    "envoy.extensions.filters.http.gzip.v3",
    "Gzip.CompressionLevel",
    GzipCompressionLevel,
)


from .......google import protobuf as ______google__protobuf__
from ...compressor import v3 as __compressor__v3__
