# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/oauth2/v3/oauth.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "CookieConfigSameSite",
    "OAuth2ConfigAuthType",
    "CookieConfig",
    "CookieConfigs",
    "OAuth2",
    "OAuth2Config",
    "OAuth2Credentials",
    "OAuth2CredentialsCookieNames",
)

import datetime
from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class CookieConfigSameSite(betterproto2.Enum):
    DISABLED = 0

    STRICT = 1

    LAX = 2

    NONE = 3


class OAuth2ConfigAuthType(betterproto2.Enum):
    URL_ENCODED_BODY = 0
    """
    The ``client_id`` and ``client_secret`` will be sent in the URL encoded request body.
    This type should only be used when Auth server does not support Basic authentication.
    """

    BASIC_AUTH = 1
    """
    The ``client_id`` and ``client_secret`` will be sent using HTTP Basic authentication scheme.
    """


@dataclass(eq=False, repr=False)
class CookieConfig(betterproto2.Message):
    """
    [#protodoc-title: OAuth]
    OAuth :ref:`configuration overview <config_http_filters_oauth>`.
    [#extension: envoy.filters.http.oauth2]

    OAuth cookie configuration attributes.
    """

    same_site: "CookieConfigSameSite" = betterproto2.field(
        1, betterproto2.TYPE_ENUM, default_factory=lambda: CookieConfigSameSite(0)
    )
    """
    The value used for the SameSite cookie attribute.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.oauth2.v3", "CookieConfig", CookieConfig
)


@dataclass(eq=False, repr=False)
class CookieConfigs(betterproto2.Message):
    """
    [#next-free-field: 8]
    """

    bearer_token_cookie_config: "CookieConfig | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the bearer token cookie.
    """

    oauth_hmac_cookie_config: "CookieConfig | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the OAuth HMAC cookie.
    """

    oauth_expires_cookie_config: "CookieConfig | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the OAuth expires cookie.
    """

    id_token_cookie_config: "CookieConfig | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the ID token cookie.
    """

    refresh_token_cookie_config: "CookieConfig | None" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the refresh token cookie.
    """

    oauth_nonce_cookie_config: "CookieConfig | None" = betterproto2.field(
        6, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the OAuth nonce cookie.
    """

    code_verifier_cookie_config: "CookieConfig | None" = betterproto2.field(
        7, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration for the code verifier cookie.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.oauth2.v3", "CookieConfigs", CookieConfigs
)


@dataclass(eq=False, repr=False)
class OAuth2(betterproto2.Message):
    """
    Filter config.
    """

    config: "OAuth2Config | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Leave this empty to disable OAuth2 for a specific route, using per filter config.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.oauth2.v3", "OAuth2", OAuth2
)


@dataclass(eq=False, repr=False)
class OAuth2Config(betterproto2.Message):
    """
    OAuth config

    [#next-free-field: 23]
    """

    token_endpoint: "_____config__core__v3__.HttpUri | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Endpoint on the authorization server to retrieve the access token from.
    """

    retry_policy: "_____config__core__v3__.RetryPolicy | None" = betterproto2.field(
        18, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Specifies the retry policy for requests to the OAuth server. If not specified, then no retries will be performed.
    """

    authorization_endpoint: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The endpoint redirect to for authorization in response to unauthorized requests.
    """

    credentials: "OAuth2Credentials | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Credentials used for OAuth.
    """

    redirect_uri: "str" = betterproto2.field(4, betterproto2.TYPE_STRING)
    """
    The redirect URI passed to the authorization endpoint. Supports header formatting
    tokens. For more information, including details on header value syntax, see the
    documentation on :ref:`custom request headers <config_http_conn_man_headers_custom_request_headers>`.

    This URI should not contain any query parameters.
    """

    redirect_path_matcher: "_____type__matcher__v3__.PathMatcher | None" = (
        betterproto2.field(5, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Matching criteria used to determine whether a path appears to be the result of a redirect from the authorization server.
    """

    signout_path: "_____type__matcher__v3__.PathMatcher | None" = betterproto2.field(
        6, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The path to sign a user out, clearing their credential cookies.
    """

    forward_bearer_token: "bool" = betterproto2.field(7, betterproto2.TYPE_BOOL)
    """
    Forward the OAuth token as a Bearer to upstream web service.
    """

    preserve_authorization_header: "bool" = betterproto2.field(
        16, betterproto2.TYPE_BOOL
    )
    """
    If set to true, preserve the existing authorization header.
    By default the client strips the existing authorization header before forwarding upstream.
    Can not be set to true if forward_bearer_token is already set to true.
    Default value is false.
    """

    pass_through_matcher: "list[_____config__route__v3__.HeaderMatcher]" = (
        betterproto2.field(8, betterproto2.TYPE_MESSAGE, repeated=True)
    )
    """
    Any request that matches any of the provided matchers will be passed through without OAuth validation.
    """

    auth_scopes: "list[str]" = betterproto2.field(
        9, betterproto2.TYPE_STRING, repeated=True
    )
    """
    Optional list of OAuth scopes to be claimed in the authorization request. If not specified,
    defaults to "user" scope.
    OAuth RFC https://tools.ietf.org/html/rfc6749#section-3.3
    """

    resources: "list[str]" = betterproto2.field(
        10, betterproto2.TYPE_STRING, repeated=True
    )
    """
    Optional resource parameter for authorization request
    RFC: https://tools.ietf.org/html/rfc8707
    """

    auth_type: "OAuth2ConfigAuthType" = betterproto2.field(
        11, betterproto2.TYPE_ENUM, default_factory=lambda: OAuth2ConfigAuthType(0)
    )
    """
    Defines how ``client_id`` and ``client_secret`` are sent in OAuth client to OAuth server requests.
    RFC https://datatracker.ietf.org/doc/html/rfc6749#section-2.3.1
    """

    use_refresh_token: "bool | None" = betterproto2.field(
        12,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.BoolValue,
        optional=True,
    )
    """
    If set to true, allows automatic access token refresh using the associated refresh token (see
    `RFC 6749 section 6 <https://datatracker.ietf.org/doc/html/rfc6749#section-6>`_), provided that the OAuth server supports that.
    Default value is true.
    """

    default_expires_in: "datetime.timedelta | None" = betterproto2.field(
        13,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The default lifetime in seconds of the access token, if omitted by the authorization server.

    If this value is not set, it will default to ``0s``. In this case, the expiry must be set by
    the authorization server or the OAuth flow will fail.
    """

    deny_redirect_matcher: "list[_____config__route__v3__.HeaderMatcher]" = (
        betterproto2.field(14, betterproto2.TYPE_MESSAGE, repeated=True)
    )
    """
    Any request that matches any of the provided matchers won't be redirected to OAuth server when tokens are not valid.
    Automatic access token refresh will be performed for these requests, if enabled.
    This behavior can be useful for AJAX requests.
    """

    default_refresh_token_expires_in: "datetime.timedelta | None" = betterproto2.field(
        15,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The default lifetime in seconds of the refresh token, if the exp (expiration time) claim is omitted in the refresh token or the refresh token is not JWT.

    If this value is not set, it will default to ``604800s``. In this case, the cookie with the refresh token will be expired
    in a week.
    This setting is only considered if ``use_refresh_token`` is set to true, otherwise the authorization server expiration or ``default_expires_in`` is used.
    """

    disable_id_token_set_cookie: "bool" = betterproto2.field(17, betterproto2.TYPE_BOOL)
    """
    If set to true, the client will not set a cookie for ID Token even if one is received from the Identity Provider. This may be useful in cases where the ID
    Token is too large for HTTP cookies (longer than 4096 characters). Enabling this option will only disable setting the cookie response header, the filter
    will still process incoming ID Tokens as part of the HMAC if they are there. This is to ensure compatibility while switching this setting on. Future
    sessions would not set the IdToken cookie header.
    """

    disable_access_token_set_cookie: "bool" = betterproto2.field(
        19, betterproto2.TYPE_BOOL
    )
    """
    If set to true, the client will not set a cookie for Access Token even if one is received from the Identity Provider.
    Enabling this option will only disable setting the cookie response header, the filter
    will still process incoming Access Tokens as part of the HMAC if they are there. This is to ensure compatibility while switching this setting on. Future
    sessions would not set the Access Token cookie header.
    """

    disable_refresh_token_set_cookie: "bool" = betterproto2.field(
        20, betterproto2.TYPE_BOOL
    )
    """
    If set to true, the client will not set a cookie for Refresh Token even if one is received from the Identity Provider.
    Enabling this option will only disable setting the cookie response header, the filter
    will still process incoming Refresh Tokens as part of the HMAC if they are there. This is to ensure compatibility while switching this setting on. Future
    sessions would not set the Refresh Token cookie header.
    """

    cookie_configs: "CookieConfigs | None" = betterproto2.field(
        21, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Controls for attributes that can be set on the cookies.
    """

    stat_prefix: "str" = betterproto2.field(22, betterproto2.TYPE_STRING)
    """
    Optional additional prefix to use when emitting statistics.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.oauth2.v3", "OAuth2Config", OAuth2Config
)


@dataclass(eq=False, repr=False)
class OAuth2Credentials(betterproto2.Message):
    """
    [#next-free-field: 6]

    Oneofs:
        - token_formation: Configures how the secret token should be created.
    """

    client_id: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The client_id to be used in the authorize calls. This value will be URL encoded when sent to the OAuth server.
    """

    token_secret: "____transport_sockets__tls__v3__.SdsSecretConfig | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The secret used to retrieve the access token. This value will be URL encoded when sent to the OAuth server.
    """

    hmac_secret: "____transport_sockets__tls__v3__.SdsSecretConfig | None" = (
        betterproto2.field(
            3, betterproto2.TYPE_MESSAGE, optional=True, group="token_formation"
        )
    )
    """
    If present, the secret token will be a HMAC using the provided secret.
    """

    cookie_names: "OAuth2CredentialsCookieNames | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The cookie names used in OAuth filters flow.
    """

    cookie_domain: "str" = betterproto2.field(5, betterproto2.TYPE_STRING)
    """
    The domain to set the cookie on. If not set, the cookie will default to the host of the request, not including the subdomains.
    This is useful when token cookies need to be shared across multiple subdomains.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.oauth2.v3", "OAuth2Credentials", OAuth2Credentials
)


@dataclass(eq=False, repr=False)
class OAuth2CredentialsCookieNames(betterproto2.Message):
    """
    [#next-free-field: 8]
    """

    bearer_token: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    Cookie name to hold OAuth bearer token value. When the authentication server validates the
    client and returns an authorization token back to the OAuth filter, no matter what format
    that token is, if :ref:`forward_bearer_token <envoy_v3_api_field_extensions.filters.http.oauth2.v3.OAuth2Config.forward_bearer_token>`
    is set to true the filter will send over the bearer token as a cookie with this name to the
    upstream. Defaults to ``BearerToken``.
    """

    oauth_hmac: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    Cookie name to hold OAuth HMAC value. Defaults to ``OauthHMAC``.
    """

    oauth_expires: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    Cookie name to hold OAuth expiry value. Defaults to ``OauthExpires``.
    """

    id_token: "str" = betterproto2.field(4, betterproto2.TYPE_STRING)
    """
    Cookie name to hold the id token. Defaults to ``IdToken``.
    """

    refresh_token: "str" = betterproto2.field(5, betterproto2.TYPE_STRING)
    """
    Cookie name to hold the refresh token. Defaults to ``RefreshToken``.
    """

    oauth_nonce: "str" = betterproto2.field(6, betterproto2.TYPE_STRING)
    """
    Cookie name to hold the nonce value. Defaults to ``OauthNonce``.
    """

    code_verifier: "str" = betterproto2.field(7, betterproto2.TYPE_STRING)
    """
    Cookie name to hold the PKCE code verifier. Defaults to ``OauthCodeVerifier``.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.oauth2.v3",
    "OAuth2Credentials.CookieNames",
    OAuth2CredentialsCookieNames,
)


from .......google import protobuf as ______google__protobuf__
from ......config.core import v3 as _____config__core__v3__
from ......config.route import v3 as _____config__route__v3__
from ......type.matcher import v3 as _____type__matcher__v3__
from .....transport_sockets.tls import v3 as ____transport_sockets__tls__v3__
