# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/stateful_session/v3/stateful_session.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "StatefulSession",
    "StatefulSessionPerRoute",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class StatefulSession(betterproto2.Message):
    """
    [#protodoc-title: Stateful session filter]
    Stateful session :ref:`configuration overview <config_http_filters_stateful_session>`.
    [#extension: envoy.filters.http.stateful_session]
    """

    session_state: "_____config__core__v3__.TypedExtensionConfig | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Specifies the implementation of session state. This session state is used to store and retrieve the address of the
    upstream host assigned to the session.

    [#extension-category: envoy.http.stateful_session]
    """

    strict: "bool" = betterproto2.field(2, betterproto2.TYPE_BOOL)
    """
    Determines whether the HTTP request must be strictly routed to the requested destination. When set to ``true``,
    if the requested destination is unavailable, Envoy will return a 503 status code. The default value is ``false``,
    which allows Envoy to fall back to its load balancing mechanism. In this case, if the requested destination is not
    found, the request will be routed according to the load balancing algorithm.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.stateful_session.v3",
    "StatefulSession",
    StatefulSession,
)


@dataclass(eq=False, repr=False)
class StatefulSessionPerRoute(betterproto2.Message):
    """


    Oneofs:
        - override:
    """

    disabled: "bool | None" = betterproto2.field(
        1, betterproto2.TYPE_BOOL, optional=True, group="override"
    )
    """
    Disable the stateful session filter for this particular vhost or route. If disabled is
    specified in multiple per-filter-configs, the most specific one will be used.
    """

    stateful_session: "StatefulSession | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True, group="override"
    )
    """
    Per-route stateful session configuration that can be served by RDS or static route table.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.http.stateful_session.v3",
    "StatefulSessionPerRoute",
    StatefulSessionPerRoute,
)


from ......config.core import v3 as _____config__core__v3__
