# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/network/generic_proxy/action/v3/action.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("RouteAction",)

import datetime
from dataclasses import dataclass

import betterproto2

from ........message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class RouteAction(betterproto2.Message):
    """
    [#protodoc-title: Generic Proxy Route Action Configuration]

    Configuration for the route match action.
    [#next-free-field: 8]

    Oneofs:
        - cluster_specifier:
    """

    name: "str" = betterproto2.field(5, betterproto2.TYPE_STRING)
    """
    The name of the route action. This should be unique across all route actions.
    """

    cluster: "str | None" = betterproto2.field(
        1, betterproto2.TYPE_STRING, optional=True, group="cluster_specifier"
    )
    """
    Indicates the upstream cluster to which the request should be routed.
    """

    weighted_clusters: "______config__route__v3__.WeightedCluster | None" = (
        betterproto2.field(
            2, betterproto2.TYPE_MESSAGE, optional=True, group="cluster_specifier"
        )
    )
    """
    [#not-implemented-hide:]
    Multiple upstream clusters can be specified for a given route. The request is routed to one
    of the upstream clusters based on weights assigned to each cluster.
    Currently ClusterWeight only supports the name and weight fields.
    """

    metadata: "______config__core__v3__.Metadata | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Route metadata.
    """

    per_filter_config: "dict[str, _______google__protobuf__.Any]" = betterproto2.field(
        4,
        betterproto2.TYPE_MAP,
        map_meta=betterproto2.map_meta(
            betterproto2.TYPE_STRING, betterproto2.TYPE_MESSAGE
        ),
    )
    """
    Route level config for L7 generic filters. The key should be the related :ref:`extension name
    <envoy_v3_api_field_config.core.v3.TypedExtensionConfig.name>` in the :ref:`generic filters
    <envoy_v3_api_field_extensions.filters.network.generic_proxy.v3.GenericProxy.filters>`.
    """

    timeout: "datetime.timedelta | None" = betterproto2.field(
        6,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _______google__protobuf__.Duration,
        optional=True,
    )
    """
    Specifies the upstream timeout for the route. If not specified, the default is 15s. This
    spans between the point at which the entire downstream request (i.e. end-of-stream) has been
    processed and when the upstream response has been completely processed. A value of 0 will
    disable the route's timeout.
    """

    retry_policy: "______config__core__v3__.RetryPolicy | None" = betterproto2.field(
        7, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Specifies the retry policy for the route. If not specified, then no retries will be performed.

    .. note::
      Only simplest retry policy is supported and only ``num_retries`` field is used for generic
      proxy. The default value for ``num_retries`` is 1 means that the request will be tried once
      and no additional retries will be performed.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.generic_proxy.action.v3",
    "RouteAction",
    RouteAction,
)


from ........google import protobuf as _______google__protobuf__
from .......config.core import v3 as ______config__core__v3__
from .......config.route import v3 as ______config__route__v3__
