# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/network/generic_proxy/v3/generic_proxy.proto, envoy/extensions/filters/network/generic_proxy/v3/route.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "GenericProxy",
    "GenericRds",
    "RouteConfiguration",
    "VirtualHost",
)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class GenericProxy(betterproto2.Message):
    """
    [#protodoc-title: Generic Proxy]
    Generic proxy.
    [#extension: envoy.filters.network.generic_proxy]

    [#next-free-field: 8]

    Oneofs:
        - route_specifier:
    """

    stat_prefix: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The human readable prefix to use when emitting statistics.
    """

    codec_config: "_____config__core__v3__.TypedExtensionConfig | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The codec which encodes and decodes the application protocol.
    [#extension-category: envoy.generic_proxy.codecs]
    """

    generic_rds: "GenericRds | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True, group="route_specifier"
    )
    """
    The generic proxies route table will be dynamically loaded via the meta RDS API.
    """

    route_config: "RouteConfiguration | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True, group="route_specifier"
    )
    """
    The route table for the generic proxy is static and is specified in this property.
    """

    filters: "list[_____config__core__v3__.TypedExtensionConfig]" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    A list of individual Layer-7 filters that make up the filter chain for requests made to the
    proxy. Order matters as the filters are processed sequentially as request events
    happen.
    [#extension-category: envoy.generic_proxy.filters]
    """

    tracing: "__http_connection_manager__v3__.HttpConnectionManagerTracing | None" = (
        betterproto2.field(6, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Tracing configuration for the generic proxy.
    """

    access_log: "list[_____config__accesslog__v3__.AccessLog]" = betterproto2.field(
        7, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    Configuration for :ref:`access logs <arch_overview_access_logs>` emitted by generic proxy.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.generic_proxy.v3", "GenericProxy", GenericProxy
)


@dataclass(eq=False, repr=False)
class GenericRds(betterproto2.Message):
    config_source: "_____config__core__v3__.ConfigSource | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Configuration source specifier for RDS.
    """

    route_config_name: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The name of the route configuration. This name will be passed to the RDS API. This allows an
    Envoy configuration with multiple generic proxies to use different route configurations.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.generic_proxy.v3", "GenericRds", GenericRds
)


@dataclass(eq=False, repr=False)
class RouteConfiguration(betterproto2.Message):
    """
    The generic proxy makes use of the xDS matching API for routing configurations.

    In the below example, we combine a top level tree matcher with a linear matcher to match
    the incoming requests, and send the matching requests to v1 of the upstream service.

    .. code-block:: yaml

      name: example
      routes:
        matcher_tree:
          input:
            name: request-service
            typed_config:
              "@type": type.googleapis.com/envoy.extensions.filters.network.generic_proxy.matcher.v3.ServiceMatchInput
          exact_match_map:
            map:
              service_name_0:
                matcher:
                  matcher_list:
                    matchers:
                    - predicate:
                        and_matcher:
                          predicate:
                          - single_predicate:
                              input:
                                name: request-properties
                                typed_config:
                                  "@type": type.googleapis.com/envoy.extensions.filters.network.generic_proxy.matcher.v3.PropertyMatchInput
                                  property_name: version
                              value_match:
                                exact: v1
                          - single_predicate:
                              input:
                                name: request-properties
                                typed_config:
                                  "@type": type.googleapis.com/envoy.extensions.filters.network.generic_proxy.matcher.v3.PropertyMatchInput
                                  property_name: user
                              value_match:
                                exact: john
                      on_match:
                        action:
                          name: route
                          typed_config:
                            "@type": type.googleapis.com/envoy.extensions.filters.network.generic_proxy.action.v3.routeAction
                            cluster: cluster_0
    """

    name: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The name of the route configuration. For example, it might match route_config_name in
    envoy.extensions.filters.network.generic_proxy.v3.Rds.
    """

    routes: "______xds__type__matcher__v3__.Matcher | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The match tree to use when resolving route actions for incoming requests.
    If no any virtual host is configured in the ``virtual_hosts`` field or no special wildcard
    virtual host is configured, the ``routes`` field will be used as the default route table.
    If both the wildcard virtual host and ``routes`` are configured, the configuration will fail
    to load.
    """

    virtual_hosts: "list[VirtualHost]" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    An array of virtual hosts that make up the route table.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.generic_proxy.v3",
    "RouteConfiguration",
    RouteConfiguration,
)


@dataclass(eq=False, repr=False)
class VirtualHost(betterproto2.Message):
    """
    [#protodoc-title: Generic Proxy Route Configuration]
    """

    name: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The name of the virtual host.
    """

    hosts: "list[str]" = betterproto2.field(2, betterproto2.TYPE_STRING, repeated=True)
    """
    A list of hosts that will be matched to this virtual host. Wildcard hosts are supported in
    the suffix or prefix form.

    Host search order:
     1. Exact names: ``www.foo.com``.
     2. Suffix wildcards: ``*.foo.com`` or ``*-bar.foo.com``.
     3. Prefix wildcards: ``foo.*`` or ``foo-*``.
     4. Special wildcard ``*`` matching any host and will be the default virtual host.

    .. note::

      The wildcard will not match the empty string.
      e.g. ``*-bar.foo.com`` will match ``baz-bar.foo.com`` but not ``-bar.foo.com``.
      The longest wildcards match first.
      Only a single virtual host in the entire route configuration can match on ``*``. A domain
      must be unique across all virtual hosts or the config will fail to load.
    """

    routes: "______xds__type__matcher__v3__.Matcher | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The match tree to use when resolving route actions for incoming requests.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.generic_proxy.v3", "VirtualHost", VirtualHost
)


from .......xds.type.matcher import v3 as ______xds__type__matcher__v3__
from ......config.accesslog import v3 as _____config__accesslog__v3__
from ......config.core import v3 as _____config__core__v3__
from ...http_connection_manager import v3 as __http_connection_manager__v3__
