# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/network/zookeeper_proxy/v3/zookeeper_proxy.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "LatencyThresholdOverrideOpcode",
    "LatencyThresholdOverride",
    "ZooKeeperProxy",
)

import datetime
from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class LatencyThresholdOverrideOpcode(betterproto2.Enum):
    Connect = 0

    Create = 1

    Delete = 2

    Exists = 3

    GetData = 4

    SetData = 5

    GetAcl = 6

    SetAcl = 7

    GetChildren = 8

    Sync = 9

    Ping = 10

    GetChildren2 = 11

    Check = 12

    Multi = 13

    Create2 = 14

    Reconfig = 15

    CheckWatches = 16

    RemoveWatches = 17

    CreateContainer = 18

    CreateTtl = 19

    Close = 20

    SetAuth = 21

    SetWatches = 22

    GetEphemerals = 23

    GetAllChildrenNumber = 24

    SetWatches2 = 25

    AddWatch = 26


@dataclass(eq=False, repr=False)
class LatencyThresholdOverride(betterproto2.Message):
    opcode: "LatencyThresholdOverrideOpcode" = betterproto2.field(
        1,
        betterproto2.TYPE_ENUM,
        default_factory=lambda: LatencyThresholdOverrideOpcode(0),
    )
    """
    The ZooKeeper opcodes. Can be found as part of the ZooKeeper source code:

    https://github.com/apache/zookeeper/blob/master/zookeeper-server/src/main/java/org/apache/zookeeper/ZooDefs.java
    """

    threshold: "datetime.timedelta | None" = betterproto2.field(
        2,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The latency threshold override of certain opcode.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.zookeeper_proxy.v3",
    "LatencyThresholdOverride",
    LatencyThresholdOverride,
)


@dataclass(eq=False, repr=False)
class ZooKeeperProxy(betterproto2.Message):
    """
    [#protodoc-title: ZooKeeper proxy]
    ZooKeeper Proxy :ref:`configuration overview <config_network_filters_zookeeper_proxy>`.
    [#extension: envoy.filters.network.zookeeper_proxy]

    [#next-free-field: 10]
    """

    stat_prefix: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The human readable prefix to use when emitting :ref:`statistics
    <config_network_filters_zookeeper_proxy_stats>`.
    """

    access_log: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    [#not-implemented-hide:] The optional path to use for writing ZooKeeper access logs.
    If the access log field is empty, access logs will not be written.
    """

    max_packet_bytes: "int | None" = betterproto2.field(
        3,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    Messages — requests, responses and events — that are bigger than this value will
    be ignored. If it is not set, the default value is 1Mb.

    The value here should match the jute.maxbuffer property in your cluster configuration:

    https://zookeeper.apache.org/doc/r3.4.10/zookeeperAdmin.html#Unsafe+Options

    if that is set. If it isn't, ZooKeeper's default is also 1Mb.
    """

    enable_latency_threshold_metrics: "bool" = betterproto2.field(
        4, betterproto2.TYPE_BOOL
    )
    """
    Whether to emit latency threshold metrics. If not set, it defaults to false.
    If false, setting ``default_latency_threshold`` and ``latency_threshold_overrides`` will not have effect.
    """

    default_latency_threshold: "datetime.timedelta | None" = betterproto2.field(
        5,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The default latency threshold to decide the fast/slow responses and emit metrics (used for error budget calculation).

    https://sre.google/workbook/implementing-slos/

    If it is not set, the default value is 100 milliseconds.
    """

    latency_threshold_overrides: "list[LatencyThresholdOverride]" = betterproto2.field(
        6, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    List of latency threshold overrides for opcodes.
    If the threshold override of one opcode is not set, it will fallback to the default latency
    threshold.
    Specifying latency threshold overrides multiple times for one opcode is not allowed.
    """

    enable_per_opcode_request_bytes_metrics: "bool" = betterproto2.field(
        7, betterproto2.TYPE_BOOL
    )
    """
    Whether to emit per opcode request bytes metrics. If not set, it defaults to false.
    """

    enable_per_opcode_response_bytes_metrics: "bool" = betterproto2.field(
        8, betterproto2.TYPE_BOOL
    )
    """
    Whether to emit per opcode response bytes metrics. If not set, it defaults to false.
    """

    enable_per_opcode_decoder_error_metrics: "bool" = betterproto2.field(
        9, betterproto2.TYPE_BOOL
    )
    """
    Whether to emit per opcode decoder error metrics. If not set, it defaults to false.
    """


default_message_pool.register_message(
    "envoy.extensions.filters.network.zookeeper_proxy.v3",
    "ZooKeeperProxy",
    ZooKeeperProxy,
)


from .......google import protobuf as ______google__protobuf__
