# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/geoip_providers/common/v3/common.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "CommonGeoipProviderConfig",
    "CommonGeoipProviderConfigGeolocationHeadersToAdd",
)

import warnings
from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class CommonGeoipProviderConfig(betterproto2.Message):
    """
    [#protodoc-title: Common Geolocation Provider Configuration]
    Common geolocation provider :ref:`configuration overview <config_geoip_providers_common>`.
    Common configuration shared across geolocation providers.
    """

    geo_headers_to_add: "CommonGeoipProviderConfigGeolocationHeadersToAdd | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration for geolocation headers to add to request.
    """


default_message_pool.register_message(
    "envoy.extensions.geoip_providers.common.v3",
    "CommonGeoipProviderConfig",
    CommonGeoipProviderConfig,
)


@dataclass(eq=False, repr=False)
class CommonGeoipProviderConfigGeolocationHeadersToAdd(betterproto2.Message):
    """
    The set of geolocation headers to add to request. If any of the configured headers is present
    in the incoming request, it will be overridden by the :ref:`Geoip filter <config_http_filters_geoip>`.
    [#next-free-field: 13]
    """

    country: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    If set, the header will be used to populate the country ISO code associated with the IP address.
    """

    city: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    If set, the header will be used to populate the city associated with the IP address.
    """

    region: "str" = betterproto2.field(3, betterproto2.TYPE_STRING)
    """
    If set, the header will be used to populate the region ISO code associated with the IP address.
    The least specific subdivision will be selected as region value.
    """

    asn: "str" = betterproto2.field(4, betterproto2.TYPE_STRING)
    """
    If set, the header will be used to populate the ASN associated with the IP address.
    """

    is_anon: "str" = betterproto2.field(5, betterproto2.TYPE_STRING)
    """
    This field is being deprecated, use ``anon`` instead.
    """

    anon: "str" = betterproto2.field(12, betterproto2.TYPE_STRING)
    """
    If set, the IP address will be checked if it belongs to any type of anonymization network (e.g. VPN, public proxy etc)
    and header will be populated with the check result. Header value will be set to either "true" or "false" depending on the check result.
    """

    anon_vpn: "str" = betterproto2.field(6, betterproto2.TYPE_STRING)
    """
    If set, the IP address will be checked if it belongs to a VPN and header will be populated with the check result.
    Header value will be set to either "true" or "false" depending on the check result.
    """

    anon_hosting: "str" = betterproto2.field(7, betterproto2.TYPE_STRING)
    """
    If set, the IP address will be checked if it belongs to a hosting provider and header will be populated with the check result.
    Header value will be set to either "true" or "false" depending on the check result.
    """

    anon_tor: "str" = betterproto2.field(8, betterproto2.TYPE_STRING)
    """
    If set, the IP address will be checked if it belongs to a TOR exit node and header will be populated with the check result.
    Header value will be set to either "true" or "false" depending on the check result.
    """

    anon_proxy: "str" = betterproto2.field(9, betterproto2.TYPE_STRING)
    """
    If set, the IP address will be checked if it belongs to a public proxy and header will be populated with the check result.
    Header value will be set to either "true" or "false" depending on the check result.
    """

    isp: "str" = betterproto2.field(10, betterproto2.TYPE_STRING)
    """
    If set, the header will be used to populate the ISP associated with the IP address.
    """

    apple_private_relay: "str" = betterproto2.field(11, betterproto2.TYPE_STRING)
    """
    If set, the IP address will be checked if it belongs to the ISP named iCloud Private Relay and header will be populated with the check result.
    Header value will be set to either "true" or "false" depending on the check result.
    """

    def __post_init__(self) -> None:
        super().__post_init__()
        if self.is_set("is_anon"):
            warnings.warn(
                "CommonGeoipProviderConfigGeolocationHeadersToAdd.is_anon is deprecated",
                DeprecationWarning,
            )


default_message_pool.register_message(
    "envoy.extensions.geoip_providers.common.v3",
    "CommonGeoipProviderConfig.GeolocationHeadersToAdd",
    CommonGeoipProviderConfigGeolocationHeadersToAdd,
)
