# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/http/injected_credentials/oauth2/v3/oauth2.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "OAuth2AuthType",
    "OAuth2",
    "OAuth2ClientCredentials",
)

import datetime
from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


class OAuth2AuthType(betterproto2.Enum):
    BASIC_AUTH = 0
    """
    The ``client_id`` and ``client_secret`` will be sent using HTTP Basic authentication scheme.
    """

    URL_ENCODED_BODY = 1
    """
    The ``client_id`` and ``client_secret`` will be sent in the URL encoded request body.
    This type should only be used when Auth server does not support Basic authentication.
    """


@dataclass(eq=False, repr=False)
class OAuth2(betterproto2.Message):
    """
    [#protodoc-title: OAuth2 Credential]
    [#extension: envoy.http.injected_credentials.oauth2]

    OAuth2 extension can be used to retrieve an OAuth2 access token from an authorization server and inject it into the
    proxied requests.
    Currently, only the Client Credentials Grant flow is supported.
    The access token will be injected into the request headers using the ``Authorization`` header as a bearer token.

    Oneofs:
        - flow_type:
    """

    token_endpoint: "_____config__core__v3__.HttpUri | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Endpoint on the authorization server to retrieve the access token from.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-3.2) for details.
    """

    scopes: "list[str]" = betterproto2.field(2, betterproto2.TYPE_STRING, repeated=True)
    """
    Optional list of OAuth scopes to be claimed in the authorization request.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-4.4.2) for details.
    """

    client_credentials: "OAuth2ClientCredentials | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True, group="flow_type"
    )
    """
    Client Credentials Grant.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-4.4) for details.
    """

    token_fetch_retry_interval: "datetime.timedelta | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.Duration,
        optional=True,
    )
    """
    The interval between two successive retries to fetch token from Identity Provider. Default is 2 secs.
    The interval must be at least 1 second.
    """


default_message_pool.register_message(
    "envoy.extensions.http.injected_credentials.oauth2.v3", "OAuth2", OAuth2
)


@dataclass(eq=False, repr=False)
class OAuth2ClientCredentials(betterproto2.Message):
    """
    Credentials to authenticate client to the authorization server.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-2.3) for details.
    """

    client_id: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    Client ID.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-2.3.1) for details.
    """

    client_secret: "____transport_sockets__tls__v3__.SdsSecretConfig | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Client secret.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-2.3.1) for details.
    """

    auth_type: "OAuth2AuthType" = betterproto2.field(
        3, betterproto2.TYPE_ENUM, default_factory=lambda: OAuth2AuthType(0)
    )
    """
    The method to use when sending credentials to the authorization server.
    Refer to [RFC 6749: The OAuth 2.0 Authorization Framework](https://www.rfc-editor.org/rfc/rfc6749#section-2.3.1) for details.
    """


default_message_pool.register_message(
    "envoy.extensions.http.injected_credentials.oauth2.v3",
    "OAuth2.ClientCredentials",
    OAuth2ClientCredentials,
)


from .......google import protobuf as ______google__protobuf__
from ......config.core import v3 as _____config__core__v3__
from .....transport_sockets.tls import v3 as ____transport_sockets__tls__v3__
