# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/matching/input_matchers/ip/v3/ip.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("Ip",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class Ip(betterproto2.Message):
    """
    [#protodoc-title: IP matcher]
    [#extension: envoy.matching.matchers.ip]

    This input matcher matches IPv4 or IPv6 addresses against a list of CIDR
    ranges. It returns true if and only if the input IP belongs to at least one
    of these CIDR ranges. Internally, it uses a Level-Compressed trie, as
    described in the paper `IP-address lookup using LC-tries
    <https://www.nada.kth.se/~snilsson/publications/IP-address-lookup-using-LC-tries/>`_
    by S. Nilsson and G. Karlsson. For "big" lists of IPs, this matcher is more
    efficient than multiple single IP matcher, that would have a linear cost.
    """

    cidr_ranges: "list[_____config__core__v3__.CidrRange]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    Match if the IP belongs to any of these CIDR ranges.
    """

    stat_prefix: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    The human readable prefix to use when emitting statistics for the IP input
    matcher. Names in the table below are concatenated to this prefix.

    .. csv-table::
       :header: Name, Type, Description
       :widths: 1, 1, 2

       ip_parsing_failed, Counter, Total number of IP addresses the matcher was unable to parse
    """


default_message_pool.register_message(
    "envoy.extensions.matching.input_matchers.ip.v3", "Ip", Ip
)


from ......config.core import v3 as _____config__core__v3__
