# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/network/dns_resolver/cares/v3/cares_dns_resolver.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("CaresDnsResolverConfig",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class CaresDnsResolverConfig(betterproto2.Message):
    """
    [#protodoc-title: c-ares DNS resolver]
    [#extension: envoy.network.dns_resolver.cares]

    Configuration for c-ares DNS resolver.
    [#next-free-field: 9]
    """

    resolvers: "list[_____config__core__v3__.Address]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    A list of dns resolver addresses.
    :ref:`use_resolvers_as_fallback<envoy_v3_api_field_extensions.network.dns_resolver.cares.v3.CaresDnsResolverConfig.use_resolvers_as_fallback>`
    below dictates if the DNS client should override system defaults or only use the provided
    resolvers if the system defaults are not available, i.e., as a fallback.
    """

    use_resolvers_as_fallback: "bool" = betterproto2.field(3, betterproto2.TYPE_BOOL)
    """
    If true use the resolvers listed in the
    :ref:`resolvers<envoy_v3_api_field_extensions.network.dns_resolver.cares.v3.CaresDnsResolverConfig.resolvers>`
    field only if c-ares is unable to obtain a
    nameserver from the system (e.g., /etc/resolv.conf).
    Otherwise, the resolvers listed in the resolvers list will override the default system
    resolvers. Defaults to false.
    """

    filter_unroutable_families: "bool" = betterproto2.field(4, betterproto2.TYPE_BOOL)
    """
    The resolver will query available network interfaces and determine if there are no available
    interfaces for a given IP family. It will then filter these addresses from the results it
    presents. e.g., if there are no available IPv4 network interfaces, the resolver will not
    provide IPv4 addresses.
    """

    dns_resolver_options: "_____config__core__v3__.DnsResolverOptions | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration of DNS resolver option flags which control the behavior of the DNS resolver.
    """

    udp_max_queries: "int | None" = betterproto2.field(
        5,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    This option allows for number of UDP based DNS queries to be capped. Note, this
    is only applicable to c-ares DNS resolver currently.
    """

    query_timeout_seconds: "int | None" = betterproto2.field(
        6,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt64Value,
        optional=True,
    )
    """
    The number of seconds each name server is given to respond to a query on the first try of any given server.

    Note: While the c-ares library defaults to 2 seconds, Envoy's default (if this field is unset) is 5 seconds.
    This adjustment was made to maintain the previous behavior after users reported an increase in DNS resolution times.
    """

    query_tries: "int | None" = betterproto2.field(
        7,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: ______google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The maximum number of query attempts the resolver will make before giving up.
    Each attempt may use a different name server.

    Note: While the c-ares library defaults to 3 attempts, Envoy's default (if this field is unset) is 4 attempts.
    This adjustment was made to maintain the previous behavior after users reported an increase in DNS resolution times.
    """

    rotate_nameservers: "bool" = betterproto2.field(8, betterproto2.TYPE_BOOL)
    """
    Enable round-robin selection of name servers for DNS resolution. When enabled, the resolver will cycle through the
    list of name servers for each resolution request. This can help distribute the query load across multiple name
    servers. If disabled (default), the resolver will try name servers in the order they are configured.

    Note: This setting overrides any system configuration for name server rotation.
    """


default_message_pool.register_message(
    "envoy.extensions.network.dns_resolver.cares.v3",
    "CaresDnsResolverConfig",
    CaresDnsResolverConfig,
)


from .......google import protobuf as ______google__protobuf__
from ......config.core import v3 as _____config__core__v3__
