# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/network/socket_interface/v3/default_socket_interface.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "DefaultSocketInterface",
    "IoUringOptions",
)

from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class DefaultSocketInterface(betterproto2.Message):
    """
    [#protodoc-title: Default socket interface configuration]

    Configuration for default socket interface that relies on OS dependent syscall to create
    sockets.
    """

    io_uring_options: "IoUringOptions | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    io_uring options. io_uring is only valid in Linux with at least kernel version 5.11. Otherwise,
    Envoy will fall back to use the default socket API. If not set then io_uring will not be
    enabled.
    """


default_message_pool.register_message(
    "envoy.extensions.network.socket_interface.v3",
    "DefaultSocketInterface",
    DefaultSocketInterface,
)


@dataclass(eq=False, repr=False)
class IoUringOptions(betterproto2.Message):
    io_uring_size: "int | None" = betterproto2.field(
        1,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The size for io_uring submission queues (SQ). io_uring is built with a fixed size in each
    thread during configuration, and each io_uring operation creates a submission queue
    entry (SQE). The default is 1000.
    """

    enable_submission_queue_polling: "bool" = betterproto2.field(
        2, betterproto2.TYPE_BOOL
    )
    """
    Enable io_uring submission queue polling (SQPOLL). io_uring SQPOLL mode polls all SQEs in the
    SQ in the kernel thread. io_uring SQPOLL mode may reduce latency and increase CPU usage as a
    cost. The default is false.
    """

    read_buffer_size: "int | None" = betterproto2.field(
        3,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The size of an io_uring socket's read buffer. Each io_uring read operation will allocate a
    buffer of the given size. If the given buffer is too small, the socket will have read multiple
    times for all the data. The default is 8192.
    """

    write_timeout_ms: "int | None" = betterproto2.field(
        4,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.UInt32Value,
        optional=True,
    )
    """
    The write timeout of an io_uring socket on closing in ms. io_uring writes and closes
    asynchronously. If the remote stops reading, the io_uring write operation may never complete.
    The operation is canceled and the socket is closed after the timeout. The default is 1000.
    """


default_message_pool.register_message(
    "envoy.extensions.network.socket_interface.v3", "IoUringOptions", IoUringOptions
)


from ......google import protobuf as _____google__protobuf__
