# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/quic/connection_id_generator/quic_lb/v3/quic_lb.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("Config",)

from dataclasses import dataclass

import betterproto2

from .......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class Config(betterproto2.Message):
    """
    [#protodoc-title: QUIC-LB connection ID generator config]
    [#extension: envoy.quic.connection_id_generator.quic_lb]

    Configuration for a connection ID generator implementation for the QUIC-LB draft RFC for
    routable connection IDs.

    Connection IDs always have the length self encoded, as described in
    https://datatracker.ietf.org/doc/html/draft-ietf-quic-load-balancers#name-length-self-description.

    See https://datatracker.ietf.org/doc/html/draft-ietf-quic-load-balancers for details.

    .. warning::

       This is still a work in progress. Performance is expected to be poor. Interoperability testing
       has not yet been performed.
    [#next-free-field: 6]
    """

    unsafe_unencrypted_testing_mode: "bool" = betterproto2.field(
        1, betterproto2.TYPE_BOOL
    )
    """
    Use the unencrypted mode. This is useful for testing, but allows for linking different CIDs
    for the same connection, and leaks information about the valid server IDs in use. This should
    only be used for testing.
    """

    server_id: "_____config__core__v3__.DataSource | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    Must be at least 1 octet.
    The length of server_id and nonce_length_bytes must be 18 or less.
    See https://datatracker.ietf.org/doc/html/draft-ietf-quic-load-balancers#name-server-id-allocation.
    """

    expected_server_id_length: "int" = betterproto2.field(3, betterproto2.TYPE_UINT32)
    """
    Optional validation of the expected server ID length. If this is non-zero and the value in ``server_id``
    does not have a matching length, a configuration error is generated. This can be useful for validating
    that the server ID is valid.
    """

    nonce_length_bytes: "int" = betterproto2.field(4, betterproto2.TYPE_UINT32)
    """
    The nonce length must be at least 4 bytes.
    The length of server_id and nonce_length_bytes must be 18 bytes or less.
    """

    encryption_parameters: "____transport_sockets__tls__v3__.SdsSecretConfig | None" = (
        betterproto2.field(5, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    Configuration to fetch the encryption key and configuration version.

    The SDS service is for a :ref:`GenericSecret <envoy_v3_api_msg_extensions.transport_sockets.tls.v3.GenericSecret>`.
    The data should populate :ref:`secrets <envoy_v3_api_field_extensions.transport_sockets.tls.v3.GenericSecret.secrets>`:

    "encryption_key" must contain the 16 byte encryption key.

    "configuration_version" must contain a 1 byte unsigned integer of value less than 7.
    See https://datatracker.ietf.org/doc/html/draft-ietf-quic-load-balancers#name-config-rotation.
    """


default_message_pool.register_message(
    "envoy.extensions.quic.connection_id_generator.quic_lb.v3", "Config", Config
)


from ......config.core import v3 as _____config__core__v3__
from .....transport_sockets.tls import v3 as ____transport_sockets__tls__v3__
