# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/quic/server_preferred_address/v3/datasource.proto, envoy/extensions/quic/server_preferred_address/v3/fixed_server_preferred_address_config.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "DataSourceServerPreferredAddressConfig",
    "DataSourceServerPreferredAddressConfigAddressFamilyConfig",
    "FixedServerPreferredAddressConfig",
    "FixedServerPreferredAddressConfigAddressFamilyConfig",
)

from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class DataSourceServerPreferredAddressConfig(betterproto2.Message):
    """
    [#protodoc-title: QUIC DataSource server preferred address config]
    [#extension: envoy.quic.server_preferred_address.datasource]

    Configuration for DataSourceServerPreferredAddressConfig.
    """

    ipv4_config: "DataSourceServerPreferredAddressConfigAddressFamilyConfig | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The IPv4 address to advertise to clients for Server Preferred Address.
    """

    ipv6_config: "DataSourceServerPreferredAddressConfigAddressFamilyConfig | None" = (
        betterproto2.field(2, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The IPv6 address to advertise to clients for Server Preferred Address.
    """


default_message_pool.register_message(
    "envoy.extensions.quic.server_preferred_address.v3",
    "DataSourceServerPreferredAddressConfig",
    DataSourceServerPreferredAddressConfig,
)


@dataclass(eq=False, repr=False)
class DataSourceServerPreferredAddressConfigAddressFamilyConfig(betterproto2.Message):
    """
    Addresses for server preferred address for a single address family (IPv4 or IPv6).
    """

    address: "____config__core__v3__.DataSource | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The server preferred address sent to clients. The data must contain an IP address string.
    """

    port: "____config__core__v3__.DataSource | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The server preferred address port sent to clients. The data must contain a integer port value.

    If this is not specified, the listener's port is used.

    Note: Envoy currently must receive all packets for a QUIC connection on the same port, so unless
    :ref:`dnat_address <envoy_v3_api_field_extensions.quic.server_preferred_address.v3.DataSourceServerPreferredAddressConfig.AddressFamilyConfig.dnat_address>`
    is configured, this must be left unset.
    """

    dnat_address: "____config__core__v3__.DataSource | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    If there is a DNAT between the client and Envoy, the address that Envoy will observe
    server preferred address packets being sent to. If this is not specified, it is assumed
    there is no DNAT and the server preferred address packets will be sent to the address advertised
    to clients for server preferred address.
    """


default_message_pool.register_message(
    "envoy.extensions.quic.server_preferred_address.v3",
    "DataSourceServerPreferredAddressConfig.AddressFamilyConfig",
    DataSourceServerPreferredAddressConfigAddressFamilyConfig,
)


@dataclass(eq=False, repr=False)
class FixedServerPreferredAddressConfig(betterproto2.Message):
    """
    [#protodoc-title: QUIC fixed server preferred address config]
    [#extension: envoy.quic.server_preferred_address.fixed]

    Configuration for FixedServerPreferredAddressConfig.
    """

    ipv4_address: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    String representation of IPv4 address, i.e. "127.0.0.2".
    If not specified, none will be configured.
    """

    ipv4_config: "FixedServerPreferredAddressConfigAddressFamilyConfig | None" = (
        betterproto2.field(3, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The IPv4 address to advertise to clients for Server Preferred Address.
    This field takes precedence over
    :ref:`ipv4_address <envoy_v3_api_field_extensions.quic.server_preferred_address.v3.FixedServerPreferredAddressConfig.ipv4_address>`.
    """

    ipv6_address: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)
    """
    String representation of IPv6 address, i.e. "::1".
    If not specified, none will be configured.
    """

    ipv6_config: "FixedServerPreferredAddressConfigAddressFamilyConfig | None" = (
        betterproto2.field(4, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The IPv6 address to advertise to clients for Server Preferred Address.
    This field takes precedence over
    :ref:`ipv6_address <envoy_v3_api_field_extensions.quic.server_preferred_address.v3.FixedServerPreferredAddressConfig.ipv6_address>`.
    """


default_message_pool.register_message(
    "envoy.extensions.quic.server_preferred_address.v3",
    "FixedServerPreferredAddressConfig",
    FixedServerPreferredAddressConfig,
)


@dataclass(eq=False, repr=False)
class FixedServerPreferredAddressConfigAddressFamilyConfig(betterproto2.Message):
    """
    Addresses for server preferred address for a single address family (IPv4 or IPv6).
    """

    address: "____config__core__v3__.SocketAddress | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    The server preferred address sent to clients.

    Note: Envoy currently must receive all packets for a QUIC connection on the same port, so unless
    :ref:`dnat_address <envoy_v3_api_field_extensions.quic.server_preferred_address.v3.FixedServerPreferredAddressConfig.AddressFamilyConfig.dnat_address>`
    is configured, the port for this address must be zero, and the listener's
    port will be used instead.
    """

    dnat_address: "____config__core__v3__.SocketAddress | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )
    """
    If there is a DNAT between the client and Envoy, the address that Envoy will observe
    server preferred address packets being sent to. If this is not specified, it is assumed
    there is no DNAT and the server preferred address packets will be sent to the address advertised
    to clients for server preferred address.

    Note: Envoy currently must receive all packets for a QUIC connection on the same port, so the
    port for this address must be zero, and the listener's port will be used instead.
    """


default_message_pool.register_message(
    "envoy.extensions.quic.server_preferred_address.v3",
    "FixedServerPreferredAddressConfig.AddressFamilyConfig",
    FixedServerPreferredAddressConfigAddressFamilyConfig,
)


from .....config.core import v3 as ____config__core__v3__
