# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/transport_sockets/http_11_proxy/v3/upstream_http_11_connect.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("Http11ProxyUpstreamTransport",)

from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class Http11ProxyUpstreamTransport(betterproto2.Message):
    """
    [#protodoc-title: Upstream HTTP/1.1 Proxy]
    [#extension: envoy.transport_sockets.http_11_proxy]

    HTTP/1.1 proxy transport socket establishes an upstream connection to a proxy address
    instead of the target host's address. This behavior is triggered when the transport
    socket is configured and proxy information is provided.

    Behavior when proxying:
    =======================
    When an upstream connection is established, instead of connecting directly to the endpoint
    address, the client will connect to the specified proxy address, send an HTTP/1.1 ``CONNECT`` request
    indicating the endpoint address, and process the response. If the response has HTTP status 200,
    the connection will be passed down to the underlying transport socket.

    Configuring proxy information:
    ==============================
    Set ``typed_filter_metadata`` in :ref:`LbEndpoint.Metadata <envoy_v3_api_field_config.endpoint.v3.lbendpoint.metadata>` or :ref:`LocalityLbEndpoints.Metadata <envoy_v3_api_field_config.endpoint.v3.LocalityLbEndpoints.metadata>`.
    using the key ``envoy.http11_proxy_transport_socket.proxy_address`` and the
    proxy address in ``config::core::v3::Address`` format.
    """

    transport_socket: "____config__core__v3__.TransportSocket | None" = (
        betterproto2.field(1, betterproto2.TYPE_MESSAGE, optional=True)
    )
    """
    The underlying transport socket being wrapped. Defaults to plaintext (raw_buffer) if unset.
    """


default_message_pool.register_message(
    "envoy.extensions.transport_sockets.http_11_proxy.v3",
    "Http11ProxyUpstreamTransport",
    Http11ProxyUpstreamTransport,
)


from .....config.core import v3 as ____config__core__v3__
