# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/upstreams/tcp/v3/tcp_protocol_options.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = ("TcpProtocolOptions",)

import datetime
from dataclasses import dataclass

import betterproto2

from ......message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class TcpProtocolOptions(betterproto2.Message):
    """
    [#protodoc-title: TCP Protocol Options]
    [#extension: envoy.upstreams.tcp.tcp_protocol_options]

    TCProtocolOptions specifies TCP upstream protocol options. This object
    is used in
    :ref:`typed_extension_protocol_options<envoy_v3_api_field_config.cluster.v3.Cluster.typed_extension_protocol_options>`,
    keyed by the name ``envoy.extensions.upstreams.tcp.v3.TcpProtocolOptions``.

    .. code::

      clusters:
        - name: some_service
          connect_timeout: 5s
          typed_extension_protocol_options:
            envoy.extensions.upstreams.tcp.v3.TcpProtocolOptions:
              "@type": type.googleapis.com/envoy.extensions.upstreams.tcp.v3.TcpProtocolOptions
              idle_timeout: 10m
           .... [further cluster config]
    """

    idle_timeout: "datetime.timedelta | None" = betterproto2.field(
        1,
        betterproto2.TYPE_MESSAGE,
        unwrap=lambda: _____google__protobuf__.Duration,
        optional=True,
    )
    """
    The idle timeout for the connection. The idle timeout is defined as the period in which
    the connection is not associated with a downstream connection. When the idle timeout is
    reached, the connection will be closed.

    If not set, the default idle timeout is 10 minutes. To disable idle timeouts, explicitly set this to 0.

    .. warning::
      Disabling this timeout has a highly likelihood of yielding connection leaks due to lost TCP
      FIN packets, etc.
    """


default_message_pool.register_message(
    "envoy.extensions.upstreams.tcp.v3", "TcpProtocolOptions", TcpProtocolOptions
)


from ......google import protobuf as _____google__protobuf__
