# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/type/metadata/v3/metadata.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "MetadataKey",
    "MetadataKeyPathSegment",
    "MetadataKind",
    "MetadataKindCluster",
    "MetadataKindHost",
    "MetadataKindRequest",
    "MetadataKindRoute",
)

from dataclasses import dataclass

import betterproto2

from .....message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class MetadataKey(betterproto2.Message):
    """
    [#protodoc-title: Metadata]

    MetadataKey provides a general interface using ``key`` and ``path`` to retrieve value from
    :ref:`Metadata <envoy_v3_api_msg_config.core.v3.Metadata>`.

    For example, for the following Metadata:

    .. code-block:: yaml

       filter_metadata:
         envoy.xxx:
           prop:
             foo: bar
             xyz:
               hello: envoy

    The following MetadataKey will retrieve a string value "bar" from the Metadata.

    .. code-block:: yaml

       key: envoy.xxx
       path:
       - key: prop
       - key: foo
    """

    key: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    The key name of Metadata to retrieve the Struct from the metadata.
    Typically, it represents a builtin subsystem or custom extension.
    """

    path: "list[MetadataKeyPathSegment]" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    The path to retrieve the Value from the Struct. It can be a prefix or a full path,
    e.g. ``[prop, xyz]`` for a struct or ``[prop, foo]`` for a string in the example,
    which depends on the particular scenario.

    Note: Due to that only the key type segment is supported, the path can not specify a list
    unless the list is the last segment.
    """


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKey", MetadataKey
)


@dataclass(eq=False, repr=False)
class MetadataKeyPathSegment(betterproto2.Message):
    """
    Specifies the segment in a path to retrieve value from Metadata.
    Currently it is only supported to specify the key, i.e. field name, as one segment of a path.

    Oneofs:
        - segment:
    """

    key: "str | None" = betterproto2.field(
        1, betterproto2.TYPE_STRING, optional=True, group="segment"
    )
    """
    If specified, use the key to retrieve the value in a Struct.
    """


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKey.PathSegment", MetadataKeyPathSegment
)


@dataclass(eq=False, repr=False)
class MetadataKind(betterproto2.Message):
    """
    Describes what kind of metadata.

    Oneofs:
        - kind:
    """

    request: "MetadataKindRequest | None" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, optional=True, group="kind"
    )
    """
    Request kind of metadata.
    """

    route: "MetadataKindRoute | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True, group="kind"
    )
    """
    Route kind of metadata.
    """

    cluster: "MetadataKindCluster | None" = betterproto2.field(
        3, betterproto2.TYPE_MESSAGE, optional=True, group="kind"
    )
    """
    Cluster kind of metadata.
    """

    host: "MetadataKindHost | None" = betterproto2.field(
        4, betterproto2.TYPE_MESSAGE, optional=True, group="kind"
    )
    """
    Host kind of metadata.
    """


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKind", MetadataKind
)


@dataclass(eq=False, repr=False)
class MetadataKindCluster(betterproto2.Message):
    """
    Represents metadata from :ref:`the upstream cluster<envoy_v3_api_field_config.cluster.v3.Cluster.metadata>`.
    """

    pass


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKind.Cluster", MetadataKindCluster
)


@dataclass(eq=False, repr=False)
class MetadataKindHost(betterproto2.Message):
    """
    Represents metadata from :ref:`the upstream
    host<envoy_v3_api_field_config.endpoint.v3.LbEndpoint.metadata>`.
    """

    pass


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKind.Host", MetadataKindHost
)


@dataclass(eq=False, repr=False)
class MetadataKindRequest(betterproto2.Message):
    """
    Represents dynamic metadata associated with the request.
    """

    pass


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKind.Request", MetadataKindRequest
)


@dataclass(eq=False, repr=False)
class MetadataKindRoute(betterproto2.Message):
    """
    Represents metadata from :ref:`the route<envoy_v3_api_field_config.route.v3.Route.metadata>`.
    """

    pass


default_message_pool.register_message(
    "envoy.type.metadata.v3", "MetadataKind.Route", MetadataKindRoute
)
