# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: opentelemetry/proto/common/v1/common.proto
# plugin: python-betterproto2
# This file has been @generated

__all__ = (
    "AnyValue",
    "ArrayValue",
    "InstrumentationLibrary",
    "KeyValue",
    "KeyValueList",
    "StringKeyValue",
)

import warnings
from dataclasses import dataclass

import betterproto2

from .....message_pool import default_message_pool

betterproto2.check_compiler_version("0.5.1")


@dataclass(eq=False, repr=False)
class AnyValue(betterproto2.Message):
    """
    AnyValue is used to represent any type of attribute value. AnyValue may contain a
    primitive value such as a string or integer or it may contain an arbitrary nested
    object containing arrays, key-value lists and primitives.

    Oneofs:
        - value: The value is one of the listed fields. It is valid for all values to be unspecified
            in which case this AnyValue is considered to be "null".
    """

    string_value: "str | None" = betterproto2.field(
        1, betterproto2.TYPE_STRING, optional=True, group="value"
    )

    bool_value: "bool | None" = betterproto2.field(
        2, betterproto2.TYPE_BOOL, optional=True, group="value"
    )

    int_value: "int | None" = betterproto2.field(
        3, betterproto2.TYPE_INT64, optional=True, group="value"
    )

    double_value: "float | None" = betterproto2.field(
        4, betterproto2.TYPE_DOUBLE, optional=True, group="value"
    )

    array_value: "ArrayValue | None" = betterproto2.field(
        5, betterproto2.TYPE_MESSAGE, optional=True, group="value"
    )

    kvlist_value: "KeyValueList | None" = betterproto2.field(
        6, betterproto2.TYPE_MESSAGE, optional=True, group="value"
    )

    bytes_value: "bytes | None" = betterproto2.field(
        7, betterproto2.TYPE_BYTES, optional=True, group="value"
    )


default_message_pool.register_message(
    "opentelemetry.proto.common.v1", "AnyValue", AnyValue
)


@dataclass(eq=False, repr=False)
class ArrayValue(betterproto2.Message):
    """
    ArrayValue is a list of AnyValue messages. We need ArrayValue as a message
    since oneof in AnyValue does not allow repeated fields.
    """

    values: "list[AnyValue]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    Array of values. The array may be empty (contain 0 elements).
    """


default_message_pool.register_message(
    "opentelemetry.proto.common.v1", "ArrayValue", ArrayValue
)


@dataclass(eq=False, repr=False)
class InstrumentationLibrary(betterproto2.Message):
    """
    InstrumentationLibrary is a message representing the instrumentation library information
    such as the fully qualified name and version.
    """

    name: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)
    """
    An empty instrumentation library name means the name is unknown. 
    """

    version: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)


default_message_pool.register_message(
    "opentelemetry.proto.common.v1", "InstrumentationLibrary", InstrumentationLibrary
)


@dataclass(eq=False, repr=False)
class KeyValue(betterproto2.Message):
    """
    KeyValue is a key-value pair that is used to store Span attributes, Link
    attributes, etc.
    """

    key: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)

    value: "AnyValue | None" = betterproto2.field(
        2, betterproto2.TYPE_MESSAGE, optional=True
    )


default_message_pool.register_message(
    "opentelemetry.proto.common.v1", "KeyValue", KeyValue
)


@dataclass(eq=False, repr=False)
class KeyValueList(betterproto2.Message):
    """
    KeyValueList is a list of KeyValue messages. We need KeyValueList as a message
    since `oneof` in AnyValue does not allow repeated fields. Everywhere else where we need
    a list of KeyValue messages (e.g. in Span) we use `repeated KeyValue` directly to
    avoid unnecessary extra wrapping (which slows down the protocol). The 2 approaches
    are semantically equivalent.
    """

    values: "list[KeyValue]" = betterproto2.field(
        1, betterproto2.TYPE_MESSAGE, repeated=True
    )
    """
    A collection of key/value pairs of key-value pairs. The list may be empty (may
    contain 0 elements).
    """


default_message_pool.register_message(
    "opentelemetry.proto.common.v1", "KeyValueList", KeyValueList
)


@dataclass(eq=False, repr=False)
class StringKeyValue(betterproto2.Message):
    """
    StringKeyValue is a pair of key/value strings. This is the simpler (and faster) version
    of KeyValue that only supports string values.
    """

    key: "str" = betterproto2.field(1, betterproto2.TYPE_STRING)

    value: "str" = betterproto2.field(2, betterproto2.TYPE_STRING)

    def __post_init__(self) -> None:
        warnings.warn("StringKeyValue is deprecated", DeprecationWarning)
        super().__post_init__()


default_message_pool.register_message(
    "opentelemetry.proto.common.v1", "StringKeyValue", StringKeyValue
)
